/*
 * $Id: Clock.java,v 1.1 2009/04/01 13:57:10 sirocic Exp $
 */
package flexray.clock;

/**
 * Interface for Clocks.
 *
 * @author Dirk Frsterling
 *
 */
public interface Clock {

    /**
     * Adding a slave to the clock
     * @param slave
     * @return the newly assigned ID for the slave.
     */
    public int addSlave( ClockSlave slave );

    /**
     * Slot for slaves to signal that they are ready.
     * @param slaveId
     */
    public void slaveReadySignal( int slaveId );

    public long getCurrentTick();

    public void pauseClock();

    public String getClockName();
}
