/*
 * $Id: ClockSlaveAdapter.java,v 1.1 2009/04/01 13:57:10 sirocic Exp $
 * 
 */
package flexray.clock;

/**
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public abstract class ClockSlaveAdapter implements Runnable , ClockSlave {

    
    private boolean ready = false; 
    private boolean slaveActive = true;
    transient Clock parentClock;
    private int mySlaveID = 0;
    
    public ClockSlaveAdapter() {
        mySlaveID = this.hashCode();
    }
        
    public void setParent( Clock pParentClock ) {
        parentClock = pParentClock;
    }
    
    /* (non-Javadoc)
     * @see flexray.clock.ClockSlave#isReady()
     */
    public boolean isReady() {
        return ready;
    }

    /* (non-Javadoc)
     * @see flexray.clock.ClockSlave#getSlaveID()
     */
    public int getSlaveID() {
        // TODO Auto-generated method stub
        return mySlaveID;
    }

    /* (non-Javadoc)
     * @see flexray.clock.ClockSlave#getSlaveName()
     */
    public String getSlaveName() {
        // TODO Auto-generated method stub
        return null;
    }
    
    public final void run() {
        while( slaveActive ) {
            try {
                synchronized( parentClock ) {
                    ready = true;

                    // signal: "ready to wait for next tick"
                    parentClock.slaveReadySignal(  mySlaveID );

                    // wait for the simulation clock.
                    parentClock.wait();
                    ready = false;
                    
                }
                doTick();
            } catch( InterruptedException e ) {
                System.err.println("Interrupt");
            }
        }
    }
    
    public abstract void doTick();

}
