/*
 * $Id: ClockSyncSlave.java,v 1.1 2009/04/01 13:57:10 sirocic Exp $
 */
package flexray.clock;

/**
 * This interface allows to implement Objects that can be "focused"
 * on to do do coarse simulation steps.
 *
 * This is accomplished by calling the <tt>tick()</tt> method of the simulation
 * clock which accepts objects implementing this interface. The simulation clock
 * will then run until <tt>getCurrentStep()</tt> returns sufficient different values.
 * <br>
 * <b>WARNING</b><br>
 * It must be ensured that <tt>getCurrentStep()</tt> really does return sufficient
 * different values.
 *
 * @author Dirk Frsterling
 * @see SimulationClock#tick(ClockSyncSlave)
 */
public interface ClockSyncSlave {

    public long getCurrentStep();

}
