/*
 * $Id: Connector.java,v 1.1 2009/04/01 13:57:09 sirocic Exp $
 *
 * Created on 05.06.2006 07:39:44 
 * by Dirk Frsterling <r@zorbla.de>
 */
package flexray.cluster;

import java.util.HashMap;
import java.util.HashSet;

import flexray.configuration.ChannelName;

/**
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public abstract class Connector {
    protected HashMap<Integer, Node> nodes = new HashMap<Integer, Node>();
    protected HashSet<Connector> connectors = new HashSet<Connector>();
    protected Cluster cluster;
    protected ChannelName channel;
    private int id;
    
    public Connector(Cluster pCluster, ChannelName pChannel, int pId) {
        this.cluster = pCluster;
        this.channel = pChannel;
        this.id = pId;
    }
    
    public abstract void connect(Connector c);
    public abstract void disconnect(Connector c);
    
    public void connect(Node n) {
        if( ! n.getNodeConfiguration().pChannels().contains(channel))
            throw new IllegalArgumentException("node not connected to channel " + channel);
        
        nodes.put(Integer.valueOf(n.getID()), n);
    }
    
    public void disconnect(Node n) {
        nodes.remove(Integer.valueOf(n.getID()));
    }
    
    public int getId() {
        return id;
    }
    
    public ChannelName getChannel() {
        return channel;
    }
    
}
