/*
 * $Id: CommCycle.java,v 1.1 2009/04/01 13:57:11 sirocic Exp $
 *
 * Created on 21.06.2006 08:41:24
 * by Dirk Frsterling <r@zorbla.de>
 */
package flexray.communication;

import flexray.configuration.ChannelName;

/**
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public class CommCycle {

    private int length = 0;

    private int slotNumbers[][];

    public CommCycle(final int length) {
        this.length = length;
        slotNumbers = new int[2][this.length];
    }

    public int getSlotNumberFromMacroTick(ChannelName channel, int macroTick) {
        switch( channel ) {
            case A:
            case B:
                return slotNumbers[channel.ordinal()][macroTick];
            default:
                throw new IllegalArgumentException("cannot give  slot number for none or two channels");
        }
    }

    public void setSlotNumberForMacroTick( ChannelName channel, int macroTick, int slot ) {
        if( macroTick < 0 ) return;
        switch( channel ) {
        case A:
        case B:
             slotNumbers[channel.ordinal()][macroTick] = slot;
             break;
        default:
            throw new IllegalArgumentException("cannot give  slot number for none or two channels");
        }
    }

    public CommCycle copy() {
        CommCycle cycle = new CommCycle(this.length);
        for( int i = 0 ; i < this.length; i++ ) {
            cycle.slotNumbers[ChannelName.A.ordinal()][i] = this.slotNumbers[ChannelName.A.ordinal()][i];
            cycle.slotNumbers[ChannelName.B.ordinal()][i] = this.slotNumbers[ChannelName.B.ordinal()][i];
        }
        return cycle;
    }

}
