/*
 * $Id: ChannelName.java,v 1.1 2009/04/01 13:57:10 sirocic Exp $
 *
 */
package flexray.configuration;


/**
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public enum ChannelName {
    A,
    B,
    AB,
    NONE;

    public boolean contains( ChannelName c ) {
        if( this.equals(NONE) || c.equals(NONE) ) return false;
        if( this.equals(c) ) return true;
        if( this.equals(AB)) return true;
        return false;
    }

    public ChannelName add( ChannelName c ) {
        switch( this ) {
        case A:
            switch (c) {
            case A:
            case NONE:
                return A;
            case B:
            case AB:
                return AB;
            }
            break; // this cannot be reached.
        case B:
            switch (c) {
            case B:
            case NONE:
                return B;
            case A:
            case AB:
                return AB;
            }
            break; // this cannot be reached.
        case AB:
            return AB;
        case NONE:
            return c;
        }
        throw new NullPointerException("The compiler wanted a return value here. I objected.");
    }

    public ChannelName other() {
        if (this.equals(A)) return B;
        if (this.equals(B)) return A;
        throw new IllegalArgumentException("No 'other' channel to " + this);
    }

    public static ChannelName[] channels() {
        return new ChannelName[] {ChannelName.A,ChannelName.B};
    }

    @Override
    public String toString() {
        if( this.equals(NONE)) return "--";
        return super.toString();
    }
}
