/*
 * $Id: ClockClickListener.java,v 1.1 2009/04/01 13:57:09 sirocic Exp $
 */
package flexray.gui;

import java.awt.Component;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

/**
 * Listener for a temporary test clock symbol to be updated.
 *
 * @author Dirk Frsterling
 *
 */
public class ClockClickListener implements MouseListener, MouseWheelListener {

    public void mouseClicked(MouseEvent e) {
        Component c = e.getComponent();
        switch( e.getButton()) {
        case MouseEvent.BUTTON3:
            ((ClockSymbol)c).tickPercent(11);
            break;
        case MouseEvent.BUTTON1:
            if ( !c.isFocusOwner() ) {
                c.requestFocus();
            } else {
                ((ClockSymbol)c).tickPercent(-11);
            }
            break;
        case MouseEvent.BUTTON2:
            c.requestFocus(); // alternative focus grabber
        }
    }

    public void mouseWheelMoved(MouseWheelEvent e) {
        int factor = 1;
        if ( (e.getModifiersEx() & InputEvent.CTRL_DOWN_MASK) > 0 ) {
            factor = 10;
        }
        ((ClockSymbol)e.getComponent()).tickPercent( -(e.getWheelRotation()*factor) );
    }

    public void mousePressed(MouseEvent e) {
    	/* dummy */
    	System.err.println(e);
    	Component parent = e.getComponent().getParent();
    	System.err.println( parent );
    	parent.dispatchEvent(e);
	}
    public void mouseReleased(MouseEvent e) { /* dummy */ }
    public void mouseEntered(MouseEvent e) { /* dummy */ }
    public void mouseExited(MouseEvent e) { /* dummy */ }

}
