/*
 * $Id: ClockDemo.java,v 1.1 2009/04/01 13:57:09 sirocic Exp $
 */
package flexray.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextArea;
import javax.swing.RepaintManager;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingUtilities;
import javax.swing.WindowConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import flexray.clock.ClockDirection;
import flexray.clock.ClockSyncSlave;
import flexray.clock.SimulatedClock;
import flexray.clock.SimulationClock;
import flexray.gui.ClockSymbol.ClockSymbolDisplayMode;
import flexray.gui.MemoryBar.PeakMode;

/**
 * Demo fr Uhren. Transient.
 *
 * @author Dirk Frsterling
 *
 */
public class ClockDemo implements WindowListener, ActionListener  {
    {
        RepaintManager.setCurrentManager( new ThreadCheckingRepaintManager() );
    }

    private JDialog closeDialog;

    static ClockSymbol sics = null;
    static ClockSymbol pcs1 = null;
    static ClockSymbol pcs2 = null;
    static ClockSymbol pcs3 = null;
    static ClockSymbol pcs4 = null;
    static ClockSymbol pcs5 = null;
    static ClockSymbol scs1 = null;
    static ClockSymbol scs2 = null;
    static JButton pause = null;
    static JSpinner delayChanger = null;
    static JSpinner delayChanger1 = null;
    static JSpinner delayChanger2 = null;
    static JSpinner delayChanger3 = null;
    static JSpinner delayChanger4 = null;
    static JSpinner delayChanger5 = null;
    static JSpinner delayChangers1 = null;
    static JSpinner delayChangers2 = null;
    static JComboBox syncChoser = null;
    static JComboBox modeChoser = null;
    static JTextArea memStat = null;
    static MemoryBar memBar = null;
    protected static int si;
    protected static int p1;
    protected static int p2;
    protected static int p3;
    protected static int p4;
    protected static int p5;
    protected static int s1;
    protected static int s2;
    protected static final int simdelay = 75;
    protected static int boundary;
    protected static SimulationClock sim;
    protected static SimulatedClock pc1;
    protected static SimulatedClock pc2;
    protected static SimulatedClock pc3;
    protected static SimulatedClock pc4;
    protected static SimulatedClock pc5;
    protected static SimulatedClock sc1;
    protected static SimulatedClock sc2;
    protected static ClockSyncSlave syncClock;

    private static int screenx;
    private static int screeny;


    public void actionPerformed( ActionEvent ae ) {
        if( ae.getActionCommand().equals("close")) {
            System.exit(0);
        }

        if( ae.getActionCommand().equals("cancel")) {
            closeCloseDialog();
        }

    }

    public void windowClosing( WindowEvent windowEvent ) {

        JButton bClose = new JButton( "Beenden" );
        bClose.addActionListener( this );
        bClose.setActionCommand("close");
        bClose.setName("close");
        bClose.setFocusPainted(false);

        JButton bCancel = new JButton( "Abbruch" );
        bCancel.addActionListener( this );
        bCancel.setActionCommand("cancel");
        bCancel.setName("cansel");
        bCancel.setFocusPainted(false);


        closeDialog = new JDialog();
        JPanel f = new JPanel(new FlowLayout( ));

        f.add(bClose);
        f.add(bCancel);

        closeDialog.setTitle( "Closing Window?" );
        closeDialog.setSize( 200, 100 );
        closeDialog.setLocation( screenx/2 - 100, screeny/2 - 50 );
        closeDialog.getContentPane().add(f);
        closeDialog.setVisible(true);
    }

    private void closeCloseDialog() {
        closeDialog.dispose();
    }

    public void windowClosed( WindowEvent windowEvent ) { /* dummy */ }
    public void windowDeiconified( WindowEvent windowEvent ) { /* dummy */ }
    public void windowIconified( WindowEvent windowEvent ) { /* dummy */ }
    public void windowActivated( WindowEvent windowEvent ) { /* dummy */ }
    public void windowDeactivated( WindowEvent windowEvent ) { /* dummy */ }
    public void windowOpened( WindowEvent windowEvent ) { /* dummy */ }


    protected static void updatePauseButton() {
        switch( sim.getDirection() ) {
        case FORWARD:
            pause.setText( ">" );
            break;
        case BACKWARD:
            pause.setText( "<" );
            break;
        }
    }

    /**
     * @param args
     */
    public static void main(String[] args) {
        JFrame.setDefaultLookAndFeelDecorated(true);
        JDialog.setDefaultLookAndFeelDecorated(true);

        final JFrame w = new JFrame( "Uhrendemo" );

        int myWidth = 400;
        int myHeight = 250;
        GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
        GraphicsDevice device  = ge.getDefaultScreenDevice();
        screenx = device.getDisplayMode().getWidth();
        screeny = device.getDisplayMode().getHeight();

        w.setLayout( new FlowLayout() );
        w.setSize( myWidth, myHeight );
        w.setLocation( screenx/2 - (myWidth/2), screeny/2 - (myHeight/2) );
        w.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        w.addWindowListener( new ClockDemo() );


        JPanel p = new JPanel( new BorderLayout());


        sics = new ClockSymbol( 40, "sim" );
        pcs1 = new ClockSymbol( 40, "1" );
        pcs2 = new ClockSymbol( 40, "2" );
        pcs3 = new ClockSymbol( 40, "3" );
        pcs4 = new ClockSymbol( 40, "4" );
        pcs5 = new ClockSymbol( 40, "5" );
        scs1 = new ClockSymbol( 40, "S1" );
        scs2 = new ClockSymbol( 40, "S2" );


        JPanel clocksAndMore = new JPanel( new BorderLayout() );
        JPanel clocks = new JPanel();
        clocksAndMore.add( clocks, BorderLayout.PAGE_START );
        JPanel clockSpinners = new JPanel();
        clocksAndMore.add( clockSpinners, BorderLayout.PAGE_END );
        JPanel movingControls = new JPanel();
        JPanel stepControls = new JPanel();
        JPanel controlPanel = new JPanel( new BorderLayout() );

        clocks.add( sics );
        clocks.add( pcs1 );
        clocks.add( pcs2 );
        clocks.add( pcs3 );
        clocks.add( pcs4 );
        clocks.add( pcs5 );
        clocks.add( scs1 );
        clocks.add( scs2 );

        p.add( clocksAndMore, BorderLayout.PAGE_START );

        delayChanger = new JSpinner( new SpinnerNumberModel(0,0,2500,1) );
        delayChanger.setPreferredSize( new Dimension( 40,28 ) );
        delayChanger.setValue( Integer.valueOf(simdelay) );
        delayChanger.addChangeListener( new ChangeListener () {
            public void stateChanged( ChangeEvent e ) {
                sim.setTickDelay( ((Integer)delayChanger.getValue()).intValue() );
            }
        });
        clockSpinners.add( delayChanger );

        delayChanger1 = new JSpinner( new SpinnerNumberModel(0,0,2500,1) );
        delayChanger1.setPreferredSize( new Dimension( 40,28 ) );
        delayChanger1.setValue( Integer.valueOf(0) );
        delayChanger1.addChangeListener( new ChangeListener () {
            public void stateChanged( ChangeEvent e ) {
                pc1.setTickDelay( ((Integer)delayChanger1.getValue()).intValue() );
            }
        });
        clockSpinners.add( delayChanger1 );

        delayChanger2 = new JSpinner( new SpinnerNumberModel(0,0,2500,1) );
        delayChanger2.setPreferredSize( new Dimension( 40,28 ) );
        delayChanger2.setValue( Integer.valueOf(0) );
        delayChanger2.addChangeListener( new ChangeListener () {
            public void stateChanged( ChangeEvent e ) {
                pc2.setTickDelay( ((Integer)delayChanger2.getValue()).intValue());
            }
        });
        clockSpinners.add( delayChanger2 );

        delayChanger3 = new JSpinner( new SpinnerNumberModel(0,0,2500,1) );
        delayChanger3.setPreferredSize( new Dimension( 40,28 ) );
        delayChanger3.setValue( Integer.valueOf(0) );
        delayChanger3.addChangeListener( new ChangeListener () {
            public void stateChanged( ChangeEvent e ) {
                pc3.setTickDelay( ((Integer)delayChanger3.getValue()).intValue() );
            }
        });
        clockSpinners.add( delayChanger3 );

        delayChanger4 = new JSpinner( new SpinnerNumberModel(0,0,2500,1) );
        delayChanger4.setPreferredSize( new Dimension( 40,28 ) );
        delayChanger4.setValue( Integer.valueOf(0) );
        delayChanger4.addChangeListener( new ChangeListener () {
            public void stateChanged( ChangeEvent e ) {
                pc4.setTickDelay( ((Integer)delayChanger4.getValue()).intValue());
            }
        });
        clockSpinners.add( delayChanger4 );

        delayChanger5 = new JSpinner( new SpinnerNumberModel(0,0,2500,1) );
        delayChanger5.setPreferredSize( new Dimension( 40,28 ) );
        delayChanger5.setValue( Integer.valueOf(0) );
        delayChanger5.addChangeListener( new ChangeListener () {
            public void stateChanged( ChangeEvent e ) {
                pc5.setTickDelay( ((Integer)delayChanger5.getValue()).intValue() );
            }
        });

        clockSpinners.add( delayChanger5 );

        delayChangers1 = new JSpinner( new SpinnerNumberModel(0,0,2500,1) );
        delayChangers1.setPreferredSize( new Dimension( 40,28 ) );
        delayChangers1.setValue( Integer.valueOf(0) );
        delayChangers1.addChangeListener( new ChangeListener () {
            public void stateChanged( ChangeEvent e ) {
                sc1.setTickDelay( ((Integer)delayChangers1.getValue()).intValue() );
            }
        });
        clockSpinners.add( delayChangers1 );

        delayChangers2 = new JSpinner( new SpinnerNumberModel(0,0,2500,1) );
        delayChangers2.setPreferredSize( new Dimension( 40,28 ) );
        delayChangers2.setValue( Integer.valueOf(0) );
        delayChangers2.addChangeListener( new ChangeListener () {
            public void stateChanged( ChangeEvent e ) {
                sc2.setTickDelay( ((Integer)delayChangers2.getValue()).intValue() );
            }
        });
        clockSpinners.add( delayChangers2 );

        pause = new JButton(">");
        pause.setActionCommand("pause");
        pause.setFocusPainted( false );
        pause.setPreferredSize( new Dimension(55,25) );
        pause.addActionListener( new ActionListener() {
            public void actionPerformed( ActionEvent ae ) {
                if( ae.getActionCommand().equals("pause")) {
                    if( !sim.isPaused() ) {
                        sim.pauseClock();
                        updatePauseButton();
                    } else {
                        pause.setText( "||" );
                        sim.resumeClock();
                    }
                }
            }
        });
        movingControls.add(pause);

        JButton direction = new JButton("<>");
        direction.setActionCommand("direction");
        direction.setFocusPainted( false );
        direction.setPreferredSize( new Dimension(60,25) );
        direction.addActionListener( new ActionListener() {
            public void actionPerformed( ActionEvent ae ) {
                if( ae.getActionCommand().equals("direction")) {
                    boolean waspaused = sim.isPaused();
                    sim.pauseClock();
                    switch( sim.getDirection() ) {
                    case FORWARD:
                        sim.setDirection( ClockDirection.BACKWARD );
                        break;
                    case BACKWARD:
                        sim.setDirection( ClockDirection.FORWARD );
                        break;
                    }
                    if( !waspaused ) {
                        sim.resumeClock();
                    } else {
                        updatePauseButton();
                    }
                }
            }
        });
        movingControls.add(direction);

        modeChoser = new JComboBox();
        for ( ClockSymbolDisplayMode m : ClockSymbolDisplayMode.values() ) {
            modeChoser.addItem( m );
        }
        modeChoser.setSelectedItem( ClockSymbolDisplayMode.DOUBLECIRCLE );
        modeChoser.addActionListener( new ActionListener() {
           public void actionPerformed( ActionEvent ae ) {
               if( ae.getActionCommand().equals("comboBoxChanged")) {
                   ClockSymbolDisplayMode newMode = (ClockSymbolDisplayMode)((JComboBox)ae.getSource()).getSelectedItem();
                   sics.setDisplayMode( newMode );
                   pcs1.setDisplayMode( newMode );
                   pcs2.setDisplayMode( newMode );
                   pcs3.setDisplayMode( newMode );
                   pcs4.setDisplayMode( newMode );
                   pcs5.setDisplayMode( newMode );
                   scs1.setDisplayMode( newMode );
                   scs2.setDisplayMode( newMode );
               }
           }
        });
        movingControls.add( modeChoser );


        JButton backleap = new JButton("|<<");
        backleap.setActionCommand("backleap");
        backleap.setPreferredSize( new Dimension(60,25) );
        backleap.setFocusPainted( false );
        backleap.addActionListener( new ActionListener() {
            public void actionPerformed( ActionEvent ae ) {
                if( ae.getActionCommand().equals("backleap")) {
                    if( sim.getCurrentTick() > 0 ) {
                        sim.pauseClock();
                        sim.setDirection( ClockDirection.BACKWARD );
                        updatePauseButton();
                        sim.tick( syncClock );
                    }
                }
            }
        });
        stepControls.add(backleap);

        JButton stepback = new JButton("|<");
        stepback.setActionCommand("stepback");
        stepback.setPreferredSize( new Dimension(60,25) );
        stepback.setFocusPainted( false );
        stepback.addActionListener( new ActionListener() {
            public void actionPerformed( ActionEvent ae ) {
                if( ae.getActionCommand().equals("stepback")) {
                    sim.pauseClock();
                    sim.setDirection( ClockDirection.BACKWARD );
                    updatePauseButton();
                    sim.tick();
                }
            }
        });
        stepControls.add(stepback);

        JButton step = new JButton(">|");
        step.setActionCommand("step");
        step.setPreferredSize( new Dimension(60,25) );
        step.setFocusPainted( false );
        step.addActionListener( new ActionListener() {
            public void actionPerformed( ActionEvent ae ) {
                if( ae.getActionCommand().equals("step")) {
                    sim.pauseClock();
                    sim.setDirection( ClockDirection.FORWARD );
                    updatePauseButton();
                    sim.tick();
                }
            }
        });
        stepControls.add(step);

        JButton leap = new JButton(">>|");
        leap.setActionCommand("leap");
        leap.setPreferredSize( new Dimension(60,25) );
        leap.setFocusPainted( false );
        leap.addActionListener( new ActionListener() {
            public void actionPerformed( ActionEvent ae ) {
                if( ae.getActionCommand().equals("leap")) {
                    sim.pauseClock();
                    sim.setDirection( ClockDirection.FORWARD );
                    updatePauseButton();
                    sim.tick( syncClock );
                }
            }
        });
        stepControls.add(leap);

        syncChoser = new JComboBox();

        stepControls.add( syncChoser );


        controlPanel.add( movingControls, BorderLayout.PAGE_START );
        controlPanel.add( stepControls, BorderLayout.PAGE_END );

        p.add( controlPanel, BorderLayout.CENTER );
        w.add( p );


        JTextArea ta = new JTextArea();
        ta.setWrapStyleWord( true );
        ta.setLineWrap(true);
        ta.setText(
                "Der Spin-Knopf rechts in der ersten Buttonzeile bestimmt das Delay fr einen Simulationsschritt.\n" +
                "\nDie Drop-Down-Box rechts in der zweiten Buttonzeile whlt diejenige Uhr aus, fr die die |<< und >>| Knpfe einen Schritt vorwrts springen.\n" +
                "\nWenn der Rckwrtslauf wieder am Anfang gekommen ist, bewegt sich nichts mehr.\n" +
                "\nUhr 1 tickt 1 mal pro 10 Simulationsticks\n" +
                "\nUhr 2 tickt 1 mal pro 10 Simulationsticks, Abweichung +5%\n" +
                "\nUhr 3 tickt 1 mal pro 10 Simulationsticks, Abweichung -5%\n" +
                "\nUhr 4 tickt 1 mal pro 10 Simulationsticks, Verzgerung 250 Ticks\n" +
                "\nUhr 5 tickt 1 mal pro 24 Simulationsticks\n" +
                "\nDer Rest drfte selbsterklrend sein.\n"
                );
        // p.add( ta, BorderLayout.PAGE_END );

        JPanel statusPanel = new JPanel( new BorderLayout() );
        p.add( statusPanel, BorderLayout.PAGE_END );

        memStat = new JTextArea();
        memStat.setWrapStyleWord( true );
        memStat.setLineWrap( true );
        memStat.setFont( Font.decode("courier") );
        memStat.setText( "Sim:");
        statusPanel.add( memStat,BorderLayout.PAGE_START );

        memBar = new MemoryBar();
        memBar.setPreferredSize( new Dimension(memBar.getWidth(), 10 ));
        memBar.setSize( new Dimension(memBar.getWidth(), 10 ));
        memBar.setPeakMode( PeakMode.PEAK_BOTH );
        memBar.setAutonomous( true );
        statusPanel.add( memBar, BorderLayout.CENTER );

        JButton jaybee = new JButton( "S!" );
        jaybee.addActionListener( new ActionListener() {
           public void actionPerformed( ActionEvent ae ) {
               if( memBar.isAutonomous() ) {
                   memBar.setPeakMode( PeakMode.PEAK_NONE );
                   memBar.setAutonomous( false );
               } else {
                   memBar.setPeakMode( PeakMode.PEAK_BOTH );
                   memBar.setAutonomous( true );
               }
           }
        });
        statusPanel.add( jaybee, BorderLayout.PAGE_END );

        sim = SimulationClock.getSimulationClock( simdelay );
        pc1 = new SimulatedClock( "Uhr 1", 10 );
        pc2 = new SimulatedClock( "Uhr 2", 10, 5.25f );
        pc3 = new SimulatedClock( "Uhr 3", 10, -5f );
        pc4 = new SimulatedClock( "Uhr 4", 10, 250 );
        pc5 = new SimulatedClock( "Uhr 5", 24 );
        sc1 = new SimulatedClock( pc1, "Uhr S1", 5 );
        sc2 = new SimulatedClock( sc1, "Uhr S2", 5 );

        syncChoser.addItem( pc1 );
        syncChoser.addItem( pc2 );
        syncChoser.addItem( pc3 );
        syncChoser.addItem( pc4 );
        syncChoser.addItem( pc5 );
        syncChoser.addItem( sc1 );
        syncChoser.addItem( sc2 );
        syncChoser.setSelectedItem( pc5 );
        syncChoser.addActionListener( new ActionListener() {
           public void actionPerformed( ActionEvent ae ) {
               if( ae.getActionCommand().equals("comboBoxChanged")) {
                   syncClock = (ClockSyncSlave)((JComboBox)ae.getSource()).getSelectedItem();
               }
           }
        });

        myWidth = w.getWidth();
        myHeight = w.getHeight();
        w.setLocation( screenx/2 - (myWidth/2), screeny/2 - (myHeight/2) );
        p.setVisible( true );
        w.pack();
        EventQueue.invokeLater( new Runnable() {
            public void run() {
                w.setVisible( true );
            }
        });


        syncClock = pc5;

        Thread t = new Thread( pc1 );
        t.start();

        t = new Thread( pc2 );
        t.start();

        t = new Thread( pc3 );
        t.start();

        t = new Thread( pc4 );
        t.start();

        t = new Thread( pc5 );
        t.start();

        t = new Thread( sc1 );
        t.start();

        t = new Thread( sc2 );
        t.start();

        sim.startClock( false );
        si = 0;
        p1 = 0;
        p2 = 0;
        p3 = 0;
        p4 = 0;
        p5 = 0;
        s1 = 0;
        s2 = 0;
        int module = 20;
        boundary = 10;

        for(;;) {
            try {
                if( sim.isPaused() ) {
                    synchronized( sim ) {
                        sim.wait( );
                    }
                } else {
                    int nSimdelay = 75;
                    int delay = 2 * nSimdelay;
                    Thread.sleep( (nSimdelay>50?50:delay) );
                    if( (sim.getCurrentTick() == 0) && (sim.isPaused()) ) {
                        EventQueue.invokeLater(new Runnable(){
                            public void run(){
                                pause.setText( ">" );
                                sim.setDirection( ClockDirection.FORWARD );
                                pause.invalidate();
                            }
                        });

                    }
                    if( (sim.getCurrentTick() == sim.getMaxTick()) && (sim.isPaused())) {
                        pause.setText( "<" );
                        sim.setDirection( ClockDirection.BACKWARD );
                        pause.invalidate();
                    }
                }

                si = (int)(sim.getCurrentTick() % module);
                p1 = (int)(pc1.getCurrentTick() % module);
                p2 = (int) (pc2.getCurrentTick() % module);
                p3 = (int) (pc3.getCurrentTick() % module);
                p4 = (int) (pc4.getCurrentTick() % module);
                p5 = (int) (pc5.getCurrentTick() % module);
                s1 = (int) (sc1.getCurrentTick() % module);
                s2 = (int) (sc2.getCurrentTick() % module);

                if( si >= boundary) {
                    sics.setGrowing( false );
                } else {
                    sics.setGrowing( true );
                }

                if( p1 >= boundary) {
                    pcs1.setGrowing( false );
                } else {
                    pcs1.setGrowing( true );
                }

                if( p2 >= boundary ) {
                    pcs2.setGrowing( false );
                } else {
                    pcs2.setGrowing( true );
                }

                if( p3 >= boundary ) {
                    pcs3.setGrowing( false );
                } else {
                    pcs3.setGrowing( true );
                }

                if( p4 >= boundary ) {
                    pcs4.setGrowing( false );
                } else {
                    pcs4.setGrowing( true );
                }

                if( p5 >= boundary ) {
                    pcs5.setGrowing( false );
                } else {
                    pcs5.setGrowing( true );
                }

                if( s1 >= boundary ) {
                    scs1.setGrowing( false );
                } else {
                    scs1.setGrowing( true );
                }

                if( s2 >= boundary ) {
                    scs2.setGrowing( false );
                } else {
                    scs2.setGrowing( true );
                }

                try {
                    SwingUtilities.invokeLater( new Runnable() {
                        public void run() {
                            sics.setPercent( (si % boundary) * (100/boundary) );
                            pcs1.setPercent( (p1 % boundary) * (100/boundary) );
                            pcs2.setPercent( (p2 % boundary)* (100/boundary) );
                            pcs3.setPercent( (p3 % boundary) * (100/boundary) );
                            pcs4.setPercent( (p4 % boundary)* (100/boundary) );
                            pcs5.setPercent( (p5 % boundary) * (100/boundary) );
                            scs1.setPercent( (s1 % boundary) * (100/boundary) );
                            scs2.setPercent( (s2 % boundary) * (100/boundary) );
                            memStat.setText( "Sim: " + sim.getCurrentTick() );
                        }
                    }
                    );
                } catch (Exception ite ) {
                    System.err.println( "InvocationTargetException" );
                }
                //memBar.repaint();
            } catch ( InterruptedException ie ) {
                System.err.println( "Interrupt!" );
            }
        }

    }

}
