/*
 * $Id: ComponentResizer.java,v 1.1 2009/04/01 13:57:10 sirocic Exp $
 *
 * Created on 25.01.2006 22:57:56
 * by Dirk Frsterling <r@zorbla.de>
 */
package flexray.gui;

import java.awt.Component;
import java.awt.event.MouseEvent;

/**
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public class ComponentResizer extends ComponentMouseAdapter {

    private static ComponentResizer cr = null;

//	private MouseListener[] ml = null;
//	private MouseMotionListener[] mml = null;
    private boolean inSize = false;

    /**
     *
     */
    public ComponentResizer() {
        super();
        // TODO Auto-generated constructor stub
    }

    public static ComponentResizer getResizer() {
        if( cr == null ) {
            cr = new ComponentResizer();
        }
        return cr;
    }

    /**
     * @param e
     * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
     */
    @Override
    public void mouseClicked(MouseEvent e) {
        // TODO Auto-generated method stub

    }

    /**
     * @param e
     * @see java.awt.event.MouseListener#mousePressed(java.awt.event.MouseEvent)
     */
    @Override
    public void mousePressed(MouseEvent e) {
        // TODO Auto-generated method stub

    }

    /**
     * @param e
     * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
     */
    @Override
    public void mouseReleased(MouseEvent e) {
        Component c = e.getComponent();
        if( ! (c instanceof Resizable) ) return;
        if( inSize ) {
            reAddOtherListeners( c );
            if( c instanceof AlphaBlendingComponent ) {
                ((AlphaBlendingComponent)c).blendToLight( false );
                c.repaint();
            }
            inSize = false;
        }
    }

    /**
     * @param e
     * @see java.awt.event.MouseListener#mouseEntered(java.awt.event.MouseEvent)
     */
    @Override
    public void mouseEntered(MouseEvent e) {
        // TODO Auto-generated method stub

    }

    /**
     * @param e
     * @see java.awt.event.MouseListener#mouseExited(java.awt.event.MouseEvent)
     */
    @Override
    public void mouseExited(MouseEvent e) {
        // TODO Auto-generated method stub

    }

    /**
     * @param e
     * @see java.awt.event.MouseMotionListener#mouseDragged(java.awt.event.MouseEvent)
     */
    @Override
    public void mouseDragged(MouseEvent e) {
        // TODO Auto-generated method stub
        Component c = e.getComponent();
        if( ! (c instanceof Resizable) ) return;
        if( inSize ) {
            int newWidth = Math.max( ((Resizable)c).getMinimumWidth(),e.getX() );
            int newHeight = Math.max( ((Resizable)c).getMinimumHeight(),e.getY() );
//			Component parent = c.getParent();
//			Component encounter = parent.getComponentAt( c.getX() + newWidth, c.getY() + newHeight );
            c.setSize( newWidth, newHeight );
            return;
        }
        if( (e.getX() > (c.getWidth() - 10)) && (e.getY() > c.getHeight() - 10)  ) {
            removeOtherListeners( c );
            if( c instanceof AlphaBlendingComponent ) {
                ((AlphaBlendingComponent)c).blendToLight( true );
            }
            int newWidth = Math.max( ((Resizable)c).getMinimumWidth(),e.getX() );
            int newHeight = Math.max( ((Resizable)c).getMinimumHeight(),e.getY() );
            c.setSize( newWidth, newHeight );
            inSize = true;
        }
    }

    /**
     * @param e
     * @see java.awt.event.MouseMotionListener#mouseMoved(java.awt.event.MouseEvent)
     */
    @Override
    public void mouseMoved(MouseEvent e) {
        // TODO Auto-generated method stub

    }

}
