/*
 * $Id: DragZone.java,v 1.1 2009/04/01 13:57:09 sirocic Exp $
 *
 * Created on 02.07.2006 09:13:43
 * by Dirk Frsterling <r@zorbla.de>
 */
package flexray.gui;

import java.awt.Rectangle;

/**
 * Interface for Components that will be dragged by the ComponentDragger but
 * only want to allow a specific rectangular area to be sensitive to dragging
 * attempts.
 *
 * @author Dirk Frsterling <r@zorbla.de>
 */
public interface DragZone {
    /**
     * Return the Rectangle describing the Area (relative to the component)
     * which is sensitive to dragging attempts.
     *
     * @return the "dragging activation area" rectangle.
     */
    public Rectangle getDragZone();
}
