/*
 * $Id: MicroFont.java,v 1.1 2009/04/01 13:57:09 sirocic Exp $
 *
 * Created on 26.06.2006 06:22:22
 * by Dirk Frsterling <r@zorbla.de>
 */
package flexray.gui;

import java.awt.Button;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.image.ImageProducer;
import java.awt.image.MemoryImageSource;
import java.util.HashMap;

/**
 * Data and functions for drawing black on transparent Characters on 5x5 pixel space
 *
 * @author Dirk Frsterling <r@zorbla.de>
 */
public class MicroFont {

//    private static final int _ = Color.WHITE.getRGB();
    @SuppressWarnings("static-access")
    private static final int _ = Color.TRANSLUCENT;
    private static final int X = Color.BLACK.getRGB();

    private static final int[] aImageData = {
        _,_,X,_,_,
        _,X,_,X,_,
        _,X,X,X,_,
        _,X,_,X,_,
        _,X,_,X,_,
    };
    private static final ImageProducer aImageProducer = new MemoryImageSource( 5, 5, aImageData, 0, 5 );
    private static final Image aImage = new Button().createImage(aImageProducer);

    private static final int[] bImageData = {
        _,X,X,_,_,
        _,X,_,X,_,
        _,X,X,_,_,
        _,X,_,X,_,
        _,X,X,_,_,
    };
    private static final ImageProducer bImageProducer = new MemoryImageSource( 5, 5, bImageData, 0, 5 );
    private static final Image bImage = new Button().createImage(bImageProducer);

    private static final int[] cImageData = {
        _,_,X,X,_,
        _,X,_,_,_,
        _,X,_,_,_,
        _,X,_,_,_,
        _,_,X,X,_,
    };
    private static final ImageProducer cImageProducer = new MemoryImageSource( 5, 5, cImageData, 0, 5 );
    private static final Image cImage = new Button().createImage(cImageProducer);

    private static final int[] dImageData = {
        _,X,X,_,_,
        _,X,_,X,_,
        _,X,_,X,_,
        _,X,_,X,_,
        _,X,X,_,_,
    };
    private static final ImageProducer dImageProducer = new MemoryImageSource( 5, 5, dImageData, 0, 5 );
    private static final Image dImage = new Button().createImage(dImageProducer);

    private static final int[] eImageData = {
        _,X,X,X,_,
        _,X,_,_,_,
        _,X,X,_,_,
        _,X,_,_,_,
        _,X,X,X,_,
    };
    private static final ImageProducer eImageProducer = new MemoryImageSource( 5, 5, eImageData, 0, 5 );
    private static final Image eImage = new Button().createImage(eImageProducer);

    private static final int[] fImageData = {
        _,X,X,X,_,
        _,X,_,_,_,
        _,X,X,_,_,
        _,X,_,_,_,
        _,X,_,_,_,
    };
    private static final ImageProducer fImageProducer = new MemoryImageSource( 5, 5, fImageData, 0, 5 );
    private static final Image fImage = new Button().createImage(fImageProducer);

    private static final int[] gImageData = {
        _,_,X,X,_,
        _,X,_,_,_,
        _,X,_,X,X,
        _,X,_,_,X,
        _,_,X,X,_,
    };
    private static final ImageProducer gImageProducer = new MemoryImageSource( 5, 5, gImageData, 0, 5 );
    private static final Image gImage = new Button().createImage(gImageProducer);

    private static final int[] hImageData = {
        _,X,_,X,_,
        _,X,_,X,_,
        _,X,X,X,_,
        _,X,_,X,_,
        _,X,_,X,_,
    };
    private static final ImageProducer hImageProducer = new MemoryImageSource( 5, 5, hImageData, 0, 5 );
    private static final Image hImage = new Button().createImage(hImageProducer);

    private static final int[] iImageData = {
        _,_,X,_,_,
        _,_,X,_,_,
        _,_,X,_,_,
        _,_,X,_,_,
        _,_,X,_,_,
    };
    private static final ImageProducer iImageProducer = new MemoryImageSource( 5, 5, iImageData, 0, 5 );
    private static final Image iImage = new Button().createImage(iImageProducer);

    private static final int[] jImageData = {
        _,_,_,X,_,
        _,_,_,X,_,
        _,_,_,X,_,
        _,X,_,X,_,
        _,_,X,_,_,
    };
    private static final ImageProducer jImageProducer = new MemoryImageSource( 5, 5, jImageData, 0, 5 );
    private static final Image jImage = new Button().createImage(jImageProducer);

    private static final int[] kImageData = {
        _,X,_,X,_,
        _,X,_,X,_,
        _,X,X,_,_,
        _,X,_,X,_,
        _,X,_,X,_,
    };
    private static final ImageProducer kImageProducer = new MemoryImageSource( 5, 5, kImageData, 0, 5 );
    private static final Image kImage = new Button().createImage(kImageProducer);

    private static final int[] lImageData = {
        _,X,_,_,_,
        _,X,_,_,_,
        _,X,_,_,_,
        _,X,_,_,_,
        _,X,X,X,_,
    };
    private static final ImageProducer lImageProducer = new MemoryImageSource( 5, 5, lImageData, 0, 5 );
    private static final Image lImage = new Button().createImage(lImageProducer);

    private static final int[] mImageData = {
        X,_,_,_,X,
        X,X,_,X,X,
        X,_,X,_,X,
        X,_,_,_,X,
        X,_,_,_,X,
    };
    private static final ImageProducer mImageProducer = new MemoryImageSource( 5, 5, mImageData, 0, 5 );
    private static final Image mImage = new Button().createImage(mImageProducer);

    private static final int[] nImageData = {
        X,_,_,_,X,
        X,X,_,_,X,
        X,_,X,_,X,
        X,_,_,X,X,
        X,_,_,_,X,
    };
    private static final ImageProducer nImageProducer = new MemoryImageSource( 5, 5, nImageData, 0, 5 );
    private static final Image nImage = new Button().createImage(nImageProducer);

    private static final int[] oImageData = {
        _,_,X,_,_,
        _,X,_,X,_,
        _,X,_,X,_,
        _,X,_,X,_,
        _,_,X,_,_,
    };
    private static final ImageProducer oImageProducer = new MemoryImageSource( 5, 5, oImageData, 0, 5 );
    private static final Image oImage = new Button().createImage(oImageProducer);

    private static final int[] pImageData = {
        _,X,X,_,_,
        _,X,_,X,_,
        _,X,X,_,_,
        _,X,_,_,_,
        _,X,_,_,_,
    };
    private static final ImageProducer pImageProducer = new MemoryImageSource( 5, 5, pImageData, 0, 5 );
    private static final Image pImage = new Button().createImage(pImageProducer);

    private static final int[] qImageData = {
        _,_,X,_,_,
        _,X,_,X,_,
        _,X,_,X,_,
        _,X,_,X,_,
        _,_,X,X,X,
    };
    private static final ImageProducer qImageProducer = new MemoryImageSource( 5, 5, qImageData, 0, 5 );
    private static final Image qImage = new Button().createImage(qImageProducer);

    private static final int[] rImageData = {
        _,X,X,_,_,
        _,X,_,X,_,
        _,X,X,_,_,
        _,X,_,X,_,
        _,X,_,X,_,
    };
    private static final ImageProducer rImageProducer = new MemoryImageSource( 5, 5, rImageData, 0, 5 );
    private static final Image rImage = new Button().createImage(rImageProducer);

    private static final int[] sImageData = {
        _,_,X,X,_,
        _,X,_,_,_,
        _,_,X,_,_,
        _,_,_,X,_,
        _,X,X,_,_,
    };
    private static final ImageProducer sImageProducer = new MemoryImageSource( 5, 5, sImageData, 0, 5 );
    private static final Image sImage = new Button().createImage(sImageProducer);

    private static final int[] tImageData = {
        _,X,X,X,_,
        _,_,X,_,_,
        _,_,X,_,_,
        _,_,X,_,_,
        _,_,X,_,_,
    };
    private static final ImageProducer tImageProducer = new MemoryImageSource( 5, 5, tImageData, 0, 5 );
    private static final Image tImage = new Button().createImage(tImageProducer);

    private static final int[] uImageData = {
        _,X,_,X,_,
        _,X,_,X,_,
        _,X,_,X,_,
        _,X,_,X,_,
        _,X,X,X,_,
    };
    private static final ImageProducer uImageProducer = new MemoryImageSource( 5, 5, uImageData, 0, 5 );
    private static final Image uImage = new Button().createImage(uImageProducer);

    private static final int[] vImageData = {
        _,X,_,X,_,
        _,X,_,X,_,
        _,X,_,X,_,
        _,X,_,X,_,
        _,_,X,_,_,
    };
    private static final ImageProducer vImageProducer = new MemoryImageSource( 5, 5, vImageData, 0, 5 );
    private static final Image vImage = new Button().createImage(vImageProducer);

    private static final int[] wImageData = {
        X,_,_,_,X,
        X,_,_,_,X,
        X,_,X,_,X,
        X,X,_,X,X,
        X,_,_,_,X,
    };
    private static final ImageProducer wImageProducer = new MemoryImageSource( 5, 5, wImageData, 0, 5 );
    private static final Image wImage = new Button().createImage(wImageProducer);

    private static final int[] xImageData = {
        _,X,_,X,_,
        _,X,_,X,_,
        _,_,X,_,_,
        _,X,_,X,_,
        _,X,_,X,_,
    };
    private static final ImageProducer xImageProducer = new MemoryImageSource( 5, 5, xImageData, 0, 5 );
    private static final Image xImage = new Button().createImage(xImageProducer);

    private static final int[] yImageData = {
        _,X,_,X,_,
        _,X,_,X,_,
        _,_,X,_,_,
        _,_,X,_,_,
        _,_,X,_,_,
    };
    private static final ImageProducer yImageProducer = new MemoryImageSource( 5, 5, yImageData, 0, 5 );
    private static final Image yImage = new Button().createImage(yImageProducer);

    private static final int[] zImageData = {
        _,X,X,X,_,
        _,_,_,X,_,
        _,_,X,_,_,
        _,X,_,_,_,
        _,X,X,X,_,
    };
    private static final ImageProducer zImageProducer = new MemoryImageSource( 5, 5, zImageData, 0, 5 );
    private static final Image zImage = new Button().createImage(zImageProducer);

    private static final HashMap<Character, Image> characters = new HashMap<Character, Image>();

    static {
        characters.put(Character.valueOf('a'), aImage);
        characters.put(Character.valueOf('b'), bImage);
        characters.put(Character.valueOf('c'), cImage);
        characters.put(Character.valueOf('d'), dImage);
        characters.put(Character.valueOf('e'), eImage);
        characters.put(Character.valueOf('f'), fImage);
        characters.put(Character.valueOf('g'), gImage);
        characters.put(Character.valueOf('h'), hImage);
        characters.put(Character.valueOf('i'), iImage);
        characters.put(Character.valueOf('j'), jImage);
        characters.put(Character.valueOf('k'), kImage);
        characters.put(Character.valueOf('l'), lImage);
        characters.put(Character.valueOf('m'), mImage);
        characters.put(Character.valueOf('n'), nImage);
        characters.put(Character.valueOf('o'), oImage);
        characters.put(Character.valueOf('p'), pImage);
        characters.put(Character.valueOf('q'), qImage);
        characters.put(Character.valueOf('r'), rImage);
        characters.put(Character.valueOf('s'), sImage);
        characters.put(Character.valueOf('t'), tImage);
        characters.put(Character.valueOf('u'), uImage);
        characters.put(Character.valueOf('v'), vImage);
        characters.put(Character.valueOf('w'), wImage);
        characters.put(Character.valueOf('x'), xImage);
        characters.put(Character.valueOf('y'), yImage);
        characters.put(Character.valueOf('z'), zImage);
    }

    /**
     * Create an image representing the given String in MicroFont
     * @param s
     * @return an image
     */
    public static Image createStringImage(final String s) {
        BufferedImage bi = new BufferedImage(s.length()*6,5,BufferedImage.TYPE_INT_ARGB);
        Graphics2D g2d = bi.createGraphics();
        for( int index = 0; index < s.length() ; index++ ) {
            g2d.drawImage(characters.get(Character.valueOf(s.toLowerCase().charAt(index))),
                          index*6, 0, null);
        }
        return bi;
    }

    /**
     * Return an Image for a single character
     * @param c
     * @return the 5x5 image for the character
     */
    public static Image getImageForChar(char c) {
        return characters.get(Character.valueOf(Character.toLowerCase(c)));
    }

}