/*
 * $Id: CancelAction.java,v 1.1 2009/04/01 13:57:10 sirocic Exp $
 *
 */
package flexray.gui.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.AbstractAction;
import javax.swing.Action;

import learningVisualizations.LeviModule;
import learningVisualizations.LeviResourceManager;


/**
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public class CancelAction extends AbstractAction
                          implements PropertyChangeListener {

    public static final String COMMAND = "Cancel";

    private LeviModule module;
    private ActionListener secondary;
    private LeviResourceManager res;

    public CancelAction(final LeviModule pModule,
                        final ActionListener secondaryActionListener) {
        module = pModule;
        secondary = secondaryActionListener;
        res = module.getRessources();
        putValue(Action.ACTION_COMMAND_KEY, COMMAND);
        putValue(Action.NAME, res.getResourceByKey("dlg.buttons.cancel"));
        res.addPropertyChangeListener(LeviResourceManager.PROPERTY_LOCALE, this);
    }

    /*
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        secondary.actionPerformed(e); // pretend we weren't here.
    }

    public void propertyChange(PropertyChangeEvent evt) {
        putValue(Action.NAME, res.getResourceByKey("dlg.buttons.calcel"));
    }

}
