/*
 * $Id: ChangeAutoMoveAction.java,v 1.1 2009/04/01 13:57:10 sirocic Exp $
 *
 * Created on 17.05.2006 11:54:13
 * by Dirk Frsterling <r@zorbla.de>
 */
package flexray.gui.actions;

import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JToggleButton;

import learningVisualizations.LeviResourceManager;

import flexray.ModuleFR;
import flexray.gui.CommCycleComponent;

/**
 * Action for allowing the CommCycle Component to beswitched between manual
 * and automatic movement.
 *
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public class ChangeAutoMoveAction extends AbstractAction {

    private CommCycleComponent ccc;
    private LeviResourceManager res;

    public ChangeAutoMoveAction(CommCycleComponent pCcc) {
        ccc = pCcc;
        res = ModuleFR.getModule().getRessources();
        setValues();
    }

    /**
     * set the action values according to the current Locale.
     *
     */
    public void setValues() {
        putValue(Action.SHORT_DESCRIPTION, res.getResourceByKey("automove.tip"));
    }

    /**
     * @param e
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        if( e.getSource() instanceof JToggleButton ) {
            JToggleButton tb = (JToggleButton)e.getSource();
            if (!tb.isSelected()) {
                ccc.setAutoMove(false);
            } else {
                ccc.setAutoMove(true);
            }
        }
    }

    /**
     *
     * @param evt
     * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
     */
    public void propertyChange(PropertyChangeEvent evt) {
        if( evt.getPropertyName().equals(LeviResourceManager.PROPERTY_LOCALE)) {
            setValues();
        }
    }

}
