/*
 * $Id: CloseCurrentScenarioAction.java,v 1.1 2009/04/01 13:57:10 sirocic Exp $
 *
 * Created on 15.05.2006 09:44:53
 * by Dirk Frsterling <r@zorbla.de>
 */
package flexray.gui.actions;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.AbstractAction;
import javax.swing.Action;

import learningVisualizations.LeviResourceManager;

import flexray.ModuleFR;


/**
 * Action for closing the current / active scenario.
 *
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public class CloseCurrentScenarioAction extends AbstractAction
                                     implements PropertyChangeListener {

    LeviResourceManager res = null;

    public CloseCurrentScenarioAction() {
        setValues();
    }

    public void setValues() {
        res = ModuleFR.getModule().getRessources();
        putValue(Action.MNEMONIC_KEY, Integer.valueOf(KeyEvent.VK_C));
        updateDisplayText();
    }

    private void updateDisplayText() {
        putValue(Action.NAME, res.getResourceByKey("scenario.close"));
    }

    /**
     *
     * @param e
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        ModuleFR.getModule().closeScenario();
    }

    /**
     *
     * @param evt
     * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
     */
    public void propertyChange(PropertyChangeEvent evt) {
        if( evt.getPropertyName().equals(LeviResourceManager.PROPERTY_LOCALE)) {
            setValues();
        }
    }

}
