/*
 * $Id: ConfigureCommCycleAction.java,v 1.2 2009/04/12 11:48:48 sirocic Exp $
 *
 * Created on 28.04.2006 07:36:24
 * by Dirk Frsterling <r@zorbla.de>
 */
package flexray.gui.actions;

import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.KeyStroke;

import learningVisualizations.LeviResourceManager;

import flexray.ModuleFR;
import flexray.gui.Property;
import flexray.gui.dialogs.CommCycleConfigDialog;
import flexray.levi.gui.FrameFR;
import flexray.scenario.FlexRayScenario;


/**
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public class ConfigureCommCycleAction extends AbstractAction
                                   implements
                                              PropertyChangeListener {

    private static final long serialVersionUID = 3860887817938902789L;
    FlexRayScenario scenario = null;
    ModuleFR moduleFR = null;
    LeviResourceManager res = null;

    public ConfigureCommCycleAction( ModuleFR module ) {
        moduleFR = module;
        res = moduleFR.getRessources();
        res.addPropertyChangeListener(Property.LOCALE,this);
        setValues();
    }


    /**
     * Adjust action values
     *
     */
    private void setValues() {
        this.putValue(Action.MNEMONIC_KEY, Integer.valueOf(KeyEvent.VK_M));
        this.putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke(res.getResourceByKey("key.edit.commcycle")));
        this.putValue(Action.NAME, res.getResourceByKey("edit.commcycle"));
        this.putValue(Action.SHORT_DESCRIPTION, res.getResourceByKey("edit.commcycle.tip"));
    }

    /**
     * @param e
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        // stop the simulation
        moduleFR.getSimulator().stopSimulation();
        // display the dialog
        CommCycleConfigDialog dialog = new CommCycleConfigDialog((FlexRayScenario)moduleFR.getScenario());
        dialog.setLocationRelativeTo((FrameFR)moduleFR.getFrame());
        dialog.setVisible( true );
        dialog.dispose();
    }

    /**
     *
     * @param evt
     * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
     */
    public void propertyChange(PropertyChangeEvent evt) {
        if( evt.getPropertyName().equals(LeviResourceManager.PROPERTY_LOCALE)) {
            setValues();
        }
    }

}
