/*
 * $Id: ConfigureNodeAction.java,v 1.1 2009/04/01 13:57:10 sirocic Exp $
 *
 * Created on 28.04.2006 07:36:24
 * by Dirk Frsterling <r@zorbla.de>
 */
package flexray.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import flexray.ModuleFR;
import flexray.gui.NodeComponent;
import flexray.gui.dialogs.NodeConfigDialog;
import flexray.levi.gui.FrameFR;
import flexray.scenario.FlexRayScenario;
import flexray.util.DebugUtil;


/**
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public class ConfigureNodeAction extends AbstractAction {

    private static final long serialVersionUID = -2844678561978927359L;
    private final ModuleFR moduleFR;

    public ConfigureNodeAction(FlexRayScenario scenario) {
        moduleFR = scenario.getLearningModule();
    }

    /**
     * @param e
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        // stop the simulation!
        moduleFR.getSimulator().stopSimulation();
        // get module environment and display dialog
        FrameFR frame = (FrameFR) moduleFR.getFrame();
        try {
        NodeConfigDialog dialog = new NodeConfigDialog(NodeComponent.getSelectedNodeComponent() );
        dialog.setLocationRelativeTo( NodeComponent.getSelectedNodeComponent() );
        dialog.showDialog(true);
        
        } catch( Exception ex ) {
            DebugUtil.println(""+ ex);
        }
    }

}
