/*
 * $Id: DeleteSelectedNodeAction.java,v 1.3 2009/04/12 11:48:48 sirocic Exp $
 *
 * Created on 26.04.2006 11:42:28
 * by Dirk Frsterling <r@zorbla.de>
 */
package flexray.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.JOptionPane;

import learningVisualizations.LeviResourceManager;
import learningVisualizations.gui.actions.LeviAbstractAction;

import flexray.ModuleFR;
import flexray.cluster.Node;
import flexray.gui.NodeComponent;
import flexray.levi.gui.FrameFR;
import flexray.scenario.FlexRayScenario;

/**
 *
 * FIXME: why is this here in flexray.gui.levi.actions?
 *
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
@SuppressWarnings("serial")
public class DeleteSelectedNodeAction extends LeviAbstractAction {

    private final ModuleFR learningModule;
    private final LeviResourceManager res;

    /**
     * This (bad) constructor is for leviSubMenu.addToMenu() only
     *
     */
    public DeleteSelectedNodeAction() {
        learningModule = ModuleFR.getModule();
        res = learningModule.getRessources();
    }

    public DeleteSelectedNodeAction(final ModuleFR learningModule) {
        this.learningModule = learningModule;
        res = this.learningModule.getRessources();
    }
    /**
     * @param e
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        FlexRayScenario scenario = (FlexRayScenario)learningModule.getScenario();
        if( scenario != null ) {
            // SHOW QUIT DIALOG
        	if (NodeComponent.getSelectedNodeComponent()!=null) {
	            Node n = NodeComponent.getSelectedNodeComponent().getNode();
	            String title = String.format(res.getResourceByKey("dlg.deletenode.title"),
	                    Integer.valueOf(n.getID()).toString());
	            String text = String.format(res.getResourceByKey("dlg.deletenode.text"),
	                    Integer.valueOf(n.getID()).toString());
	            int i = JOptionPane.showConfirmDialog(NodeComponent.getSelectedNodeComponent(), /*learningModule.getFrame()*/
	                                                  text,
	                                                  title,
	                                                  JOptionPane.YES_NO_OPTION);
	
	            if(i == JOptionPane.YES_OPTION)
	            	scenario.deleteNode(NodeComponent.getSelectedNodeComponent().getNode());
        	}
        	else {
        		// es wurde kein Knoten selektiert!!!
        		String title = String.format(res.getResourceByKey("dlg.deletenode.title"), "?");
	            String text = res.getResourceByKey("dlg.deletenode.errtext");
	            int i = JOptionPane.showConfirmDialog((FrameFR)learningModule.getFrame(), /*learningModule.getFrame()*/
	                                                  text,
	                                                  title,
	                                                  JOptionPane.OK_OPTION);
	
        	}
        }
    }

}
