/*
 * $Id: AbstractFlexRayDialog.java,v 1.1 2009/04/01 13:57:06 sirocic Exp $
 *
 */
package flexray.gui.dialogs;


import java.awt.event.ActionListener;

import learningVisualizations.LeviResourceManager;
import learningVisualizations.gui.LeviDialog;
import flexray.cluster.Cluster;
import flexray.scenario.FlexRayScenario;
import flexray.levi.help.FRHelp;

/**
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public abstract class AbstractFlexRayDialog extends LeviDialog
                                        implements ActionListener {

	
    protected final FlexRayScenario scenario;
    protected final LeviResourceManager res;
    protected final Cluster cluster;

    /**
     * Create a selection dialog for the node/slot-Configuration based
     * on the channel+Slot information ("select a node")
     *
     * @param pScenario
     */
    public AbstractFlexRayDialog(FlexRayScenario pScenario, String titleKey) {
        super(pScenario.getFrame(), titleKey);

        this.scenario = pScenario;
        this.res = myFrame.getLearningModule().getRessources();
        this.cluster = scenario.getCluster();
        boolean inTutorial = false;
        if(myFrame.getLearningModule().isHelpVisible()) {
            inTutorial = ((FRHelp)myFrame.getLearningModule().getHelp()).isTutorialMode();
        }
        setModal(!inTutorial);
        setResizable(false);
         
    }


}