package flexray.levi.visualizer;

import java.awt.Color;
import java.awt.Font;

import javax.swing.JPanel;

import flexray.ModuleFR;

import learningVisualizations.LeviModule;
import learningVisualizations.editor.LeviScenarioEditorVisualizer;

public class FRScenarioVisualizer extends LeviScenarioEditorVisualizer {
	
 /*
  * Methode:		Contructors
  * 
  * Date: 		    30.01.2008
  * @author        sirocic
  */
  public FRScenarioVisualizer(FRVisualizer myParent, ModuleFR learningModule) {   	
		  super(myParent, (LeviModule)learningModule);	
	   }
 
  /*
   * Methode:		createGraphicScenario
   *
   * Description:	Creates the graphic elements for the current scenario and repaints the panel.
   *
   * Parameters:
   *
   * Date: 		30.01.2008
   * @author        sirocic
   */
  public void createGraphicScenario() {
 
  }
  
  /*
   * Methode:		cancelAnimation
   *
   * Description:	Abrechen der aktuellen Animationen. Springen in den nchsten Zustand ohne 
   *               das die Animation vollstndig durchgelaufen ist.
   *
   * Date: 		 12.10.2006
   * @author        sirocic
   */
  public void cancelAnimation(boolean cancelByBackOrStop) {
	   // muss implementiert werden!!!
	   // Wenn das Modul eine dynamische Animation besitzt, mssen die
	   // Ablufe hier abgebrochen werden falls sie aktuell luft.
  }


  /*
   * Methode:		setDialogFont
   * 
   * Description:	Setz alle Hintergrund- und Vordergrundfarben der GUI-Element auf die aktuellen
   * 				Werte. 
   *    
   * Parameters:   Aktuelle Font fr Labels und Textfelder.
   * 
   * Date: 		 23.04.2007
   * @author        sirocic
   */	
  private void setPanelFont() {
	   Font labelFont;
	   
	   labelFont = (Font)myModule.getConfiguration().getSettingByKey("FontLabel");
	   
	   setFont(labelFont);
	   
  }
  
  /*
   * Methode:		setDialogTexte
   * 
   * Description:	Setz alle Text-Bausteine des Dialoges neu. Wichtig fr Sprachwechsel.
   *    
   * Parameters:   
   * 
   * Date: 		 23.04.2007
   * @author        sirocic
   */	
  private void setPanelTexte() {
	  
  }
  
  /*
   * Methode:		setDialogColors
   * 
   * Description:	Setz alle Hintergrund- und Vordergrundfarben der GUI-Element auf die aktuellen
   * 				Werte. 
   *    
   * Parameters:   Aktuelle Farbwerte fr Hintergrund und Vordergrund.
   * 
   * Date: 		 23.04.2007
   * @author        sirocic
   */	
  private void setPanelColors() {
	   Color foregroundColor, backgroundColor;
	   
      if(myModule.getConfiguration().getSettingByKey("ColorComponentForeground")!=null) {
   	   foregroundColor = (Color)myModule.getConfiguration().getSettingByKey("ColorComponentForeground");
	       backgroundColor = (Color)myModule.getConfiguration().getSettingByKey("ColorComponentBackground");
      }
      else {
   	   foregroundColor = (Color)myModule.getConfiguration().getSettingByKey("ColorModuleForeground");
	       backgroundColor = (Color)myModule.getConfiguration().getSettingByKey("ColorModuleBackground");
      }
      
     setBackground(backgroundColor);
	  setForeground(foregroundColor);
	 // getColumnHeader().setBackground(backgroundColor);
	 // getColumnHeader().setForeground(foregroundColor);
	 
	 
  }
  
  /*
   * Methode:		updateLanguageColorFonts
   *
   * Description:	Ldt sprachabhngige Teile neu. In der Toolbar knnen z.B. sprachabhngige
   * 				Buttons sein 
   *
   * Date: 		20.04.2007
   * 
   * @author sirocic
   */
  public void updateLanguageColorFonts()
  {
  
	  //	 SUBKOMPONENTE UPDATEN...
	  if (scenarioPanel!=null)
		  scenarioPanel.updateLanguageColorFonts();
	  
	  // 	 FARBWECHSEL ...
	   setPanelColors();

	   // FONTWECHSEL
	   setPanelFont();
	  
	   // SPRACHWECHSEL ...
	   setPanelTexte();

  }
  

  /*
   * Methode:		fitPanel
   * 
   * Description:	Bestimmen der bentigten Panelgre fr's aktuelle Szenario. 
   *               Es werden alle grafischen Elemente (Shapes) durchlaufen und jeweils
   *               der rechte untere Punkt bestimmt. Die am weitesten rechts und unten
   *               liegenden Koordinaten werden sich gemerkt. 
   *    
   * Parameters:    
   * 
   * Date: 		 17.05.2006
   * @author        sirocic
   */	
  public void fitPanel() {
	
  }
  
}