/*
 * $Id: FRVisualizer.java,v 1.3 2009/04/28 04:48:55 sirocic Exp $
 *
 */
package flexray.levi.visualizer;

import javax.swing.JPanel;

import learningVisualizations.visualizer.LeviVisualizer;
import flexray.ModuleFR;
import flexray.scenario.FlexRayScenario;
import flexray.util.DebugUtil;

/**
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public class FRVisualizer extends LeviVisualizer {

    private static final long serialVersionUID = 8145621400672331825L;

    /**
     * @param learningModule
     */
    public FRVisualizer(ModuleFR learningModule) {
        super(learningModule);
        this.scenarioVisualizer = new FRScenarioVisualizer(this, learningModule);
    }

    // 17.07.2006 BS Ab jetzt wird fr die Visualisierung der Simulationsergebnisse nicht mehr nur
    // die repaint-Methode des Visualizers aufgerufen sondern die neue Methode visualize().
    // Dies ist notwendig fr die Visualisierungen, die in einem Schritt aus mehr bestehen als
    // nur ein Refresh des Visualizer-Panels.
    @Override
    public void visualize() {
        repaint();
    }
    // END 17.07.2006 BS

    /**
     * Dirty hack to let the basic simulator update the GUI
     *
     * @see java.awt.Module#repaint()
     */
    @Override
    public void repaint() {
        if( getLearningModule() != null ) {
            if( getLearningModule().getScenario() != null ) {
                ((FlexRayScenario)getLearningModule().getScenario()).updateView();
                getLearningModule().updateStatusBar();
            }
        }
    }


    @Override
    public ModuleFR getLearningModule() {
        return (ModuleFR)super.getLearningModule();
    }
    
    public boolean isBusy() {
    	return busy;
    }
    
}
