/*
 * $Id: TextUtil.java,v 1.1 2009/04/01 13:57:11 sirocic Exp $
 */
package flexray.util;

import java.io.*;

/**
 * Klasse mit diversen kleinen Texthelfern.
 *
 * @author Dirk Frsterling
 *
 */
public class TextUtil {
    /**
     * Methode zur umwandlung eines Exception-Stacktrace
     * in eine String-Reprsentation
     *
     * @author Dirk Frsterling
     * @param e Exception, deren Stacktrace als String vorliegen soll
     * @return String-Reprsentation zum Stacktrace von e
     */
    public static String e2s( Exception e ) {
        String exceptionMessage = "";
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        PrintWriter pw = new PrintWriter( baos );
        e.printStackTrace( pw );
        pw.flush();
        exceptionMessage = baos.toString();
        return exceptionMessage;
    } // e2s

    /**
     * Methode zur Formatierung einer Byte-Anzahl in eine
     * "Menschenlesbare" Form mit den blichen Maeinheiten.
     * @author Dirk Frsterling <r@zorbla.de>
     * @param pBytes die Anzahl die zu Formatieren ist.
     * @return String mit der formatierten Ausgabe.
     */
    public static String humanReadableBytes( double pBytes ) {
        double bytes = pBytes;
        int btype = 0;
        String empty = "          ";
        String sznames[] = {"byt", "KiB", "MiB", "GiB", "TiB"};
        while (bytes > 1024) {
            btype++;
            bytes /= 1024.0;
        }
        long bytei = java.lang.Math.round(bytes * 10.0);
        bytes = bytei * 1.0;
        bytes /= 10.0;
        return "" + empty.substring(0,6-(""+bytes).length()) + bytes + " " + sznames[ btype ];
    } // humanReadableBytes

    public static void main( String[] args ) {
        System.out.println( humanReadableBytes( 123456 )  );
        System.out.println( humanReadableBytes( 1123456 )  );
    }
}
