/*
 * $Id: XMLTags.java,v 1.1 2009/04/01 13:57:11 sirocic Exp $
 *
 * Created on 25.05.2006 07:06:36
 * by Dirk Frsterling <r@zorbla.de>
 */
package flexray.xml;


/**
 * This interface defines the constats for the XML tag names used to store
 * and restore the FlexRay scenario and view.
 *
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public interface XMLTags {

    /*
     * scenario
     */
    public static final String XT_FLEXRAYSCENARIO = "flexrayscenario";
    public static final String XT_CLUSTER = "cluster";
    public static final String XT_BASICVIEW = "basicview";

    public static final String XT_CNODE = "cnode";
    public static final String XT_CNODE_ID = "id";
    public static final String XT_CNODE_NAME = "name";
    public static final String XT_CNODE_DYNFRAME = "dynframe";
    public static final String XT_CNODE_DYNFRAME_CHANNEL = "channel";
    public static final String XT_CNODE_DYNFRAME_SEND = "send";
    public static final String XT_CNODE_DYNFRAME_RANGE_MIN = "min";
    public static final String XT_CNODE_DYNFRAME_RANGE_MAX = "max";
    public static final String XT_CNODE_DYNFRAME_DIST_MIN = "dmin";
    public static final String XT_CNODE_DYNFRAME_DIST_MAX = "dmax";
    public static final String XT_CNODE_DYNFRAME_REQUEST_MIN = "dreqmin";
    public static final String XT_CNODE_DYNFRAME_REQUEST_MAX = "dreqmax";
    public static final String XT_CNODE_STATIC_SEND = "statsend";
    public static final String XT_CNODE_STATIC_CHANNEL = "channel";
    public static final String XT_CNODE_STATIC_RANGE_MIN = "min";
    public static final String XT_CNODE_STATIC_RANGE_MAX = "max";
    public static final String XT_CNODE_TRANSMITSLOT = "slot";
    public static final String XT_CNODE_CONFIG = "cnodeconfig";
    public static final String XT_CNODE_CONFIG_PCHANNELS = "pchannels";
    public static final String XT_CNODE_CONFIG_PMICROPERCYCLE = "pmicropercycle";
    public static final String XT_CNODE_CONFIG_PPAYLOADLENGTHDYNMAX = "ppayloadlengthdynmax";

    public static final String XT_CHANNEL_TOPOLOGY = "topology";
    public static final String XT_CHANNEL_TOPOLOGY_A = "a";
    public static final String XT_CHANNEL_TOPOLOGY_B = "b";

    public static final String XT_CLUSTER_CONFIG = "clusterconfig";
    public static final String XT_CLUSTER_CONFIG_GDSTATICSLOT = "gdstaticslot";
    public static final String XT_CLUSTER_CONFIG_GDMINISLOT = "gdminislot";
    public static final String XT_CLUSTER_CONFIG_GDNIT = "gdnit";
    public static final String XT_CLUSTER_CONFIG_GNUMBEROFSTATICSLOTS = "gnumberofstaticslots";
    public static final String XT_CLUSTER_CONFIG_GNUMBEROFMINISLOTS = "gnumberofminislots";


    /*
     * view
     */
    public static final String XT_NODEVIEW = "vnode";
    public static final String XT_NODEVIEW_ID = "id";

    public static final String XT_COLOR_RGB = "color";
    public static final String XT_COLOR_RGB_R = "r";
    public static final String XT_COLOR_RGB_G = "g";
    public static final String XT_COLOR_RGB_B = "b";

    public static final String XT_SCREENPOS = "screenpos";
    public static final String XT_SCREENPOS_X = "x";
    public static final String XT_SCREENPOS_Y = "y";
    public static final String XT_SCREENPOS_Z = "z";

    public static final String XT_DIMENSION = "dimension";
    public static final String XT_DIMENSION_W = "w";
    public static final String XT_DIMENSION_H = "h";

    public static final String XT_STARCOUPLERVIEW = "vstarcoupler";
    public static final String XT_STARCOUPLERVIEW_CHANNEL = "channel";

    public static final String XT_COMMCYCLEVIEW = "commcycleview";
    public static final String XT_COMMCYLCEVIEW_AUTO = "automove";

}
