/* leviParserErrorHandler.java
 * 
 * Created on 19.02.2007
 * @author sirocic
 */
package learningVisualizations;

import javax.swing.JOptionPane;
import javax.xml.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import javax.xml.validation.*;

import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * @author sirocic
 *
 * Class: leviParserErrorHandler
 *
 * Description: The class "leviParserErrorHandler" implements the error handler for the
 * 				xml scenario file parser.
 *
 * Date:	19.02.2007
 */
public class LeviParserErrorHandler implements ErrorHandler {

	private LeviModule module;
    // zeigt an, ob beim Parsen ein Error bzw. FatalError aufgetreten ist.
	private boolean errorFound = false;
	// Hilfsvariablen fr die Fehlermeldungsanzeige
	private String errorMsg;
	private String errorTitle;
	
    /**
    *
    * Methode:       Contructors
    *

    * Date:          19.02.2007
    * @author        sirocic
    */
    public LeviParserErrorHandler(LeviModule module) {
    	this.module = module;
    	this.errorFound = false;
    }
    
    /**
     * Methode:		warning
     *
     * Description:	
     * 
     * Date: 		19.02.2007
     * @author    	sirocic
     */
    public void warning(SAXParseException exception) throws SAXException {
    	module.getFrame().showWarningMessageDialog("dlg.warning.17", exception.getMessage(), "leviParserErrorHandler");  

    }
    
    /**
     * Methode:		error
     *
     * Description:	
     * 
     * Date: 		19.02.2007
     * @author    	sirocic
     */
    public void error(SAXParseException exception) throws SAXException { 
    	
    	module.getFrame().showErrorMessageDialog("dlg.errortext.17", exception.getMessage(), "leviParserErrorHandler");  
        
	    errorFound = true;
    }
    
    /**
     * Methode:		fatalError
     *
     * Description:	
     * 
     * Date: 		19.02.2007
     * @author    	sirocic
     */
    public void fatalError(SAXParseException exception) throws SAXException {
    	 
    	module.getFrame().showErrorMessageDialog("dlg.errortext.17", exception.getMessage(), "leviParserErrorHandler");  
        
	    errorFound = true;
    }
    
    /**
     * Methode:		fatalError
     *
     * Description:	
     * 
     * Date: 		19.02.2007
     * @author    	sirocic
     */
    public boolean foundError(){
	    return errorFound ;
    }
}
