package learningVisualizations.editor;

import learningVisualizations.visualizer.LeviShapeMaker;

public interface LeviScenarioEditorInterface {

	   /*
	    * Methode:		createGraphicScenario
	    *
	    * Description:	Creates the graphic elements for the current scenario and repaints the panel.
	    * 				This have to be done in the component subclass.
	    *
	    * Parameters:
	    *
	    * Date: 		 18.10.2006
	    * @author        sirocic
	    */
	   public abstract void createGraphicScenario();
	   
	   /*
	    * Methode:		cleanMe
	    *
	    * Description:	Deletes all graphical element from the scenarioPanel.
	    *
	    * Parameters:
	    *
	    * Date: 		 05.05.2006
	    * @author        sirocic
	    */
	   public void cleanMe() ;
	   
	   public void setCurrentSelected(LeviShapeMaker selectedObject);
	   public LeviShapeMaker getCurrentSelected();
	   
	   /*
	    * Methode:		updateCurrentSelection
	    *
	    * Description:	Updating the current selected object . 
	    *
	    * Date: 		17.10.2006
	    * @author       sirocic
	    */
	   public void updateCurrentSelection(LeviShapeMaker newSelection) ;
	   
	   public void removeSelectedObject();
	   public void setModus(int newModus);
	   
	   /*
	    * Methode:		updateLanguageColorFonts
	    *
	    * Description:	Ldt sprachabhngige Teile neu. In der Toolbar knnen z.B. sprachabhngige
	    * 				Buttons sein 
	    *
	    * Date: 		12.03.2007
	    * 
	    * @author sirocic
	    */
	   public abstract void updateLanguageColorFonts() ;
	   
	   public void repaint();
	   public int getWidth();
	   public int getHeight();
	 
}
