/* leviChooseButton.java
 *
 * Created on 12.09.2005
 * @author sirocic
 */
package learningVisualizations.gui;

import java.awt.*;
import java.net.*;
import javax.swing.*;

import learningVisualizations.LeviModule;


/**
 * @author sirocic
 *
 * Class: leviChooseButton
 *
 * Description: The class "leviChooseButton" represents the color and font choose button in the color and font dialog.
 *
 * Date:	12.09.2005
 */
public class LeviChooseButton extends LeviButton {

   static final long serialVersionUID=1;

   private static final Insets margins = new Insets(0,0,0,0);

   private Component preview; // the corresponding preview panel from the color/font dialog.
   private JLabel propertyLabel; // die zugehrige Bezeichnung fr die Farbe bzw. Schriftart

  /*
   * Methode:		Contructors
   *
   * Description:	Displays the current color or font setting from the configuration.
   *				Provides the user with the possiblity to change the color settings or font settings
   *                for special elements like module background, process foreground header text etc.
   *                The selected colors or fonts are store by the background color or font of the preview panels.
   *                The configuration will be updated if the confirm button was selected.
   *
   * Date: 		    07.09.2005
   * @author        sirocic
   */
   public LeviChooseButton() {
       super();
       this.preview = null;
       this.propertyLabel = null;
   }
   public LeviChooseButton(String keyLabel, LeviModule module, Component preview, JLabel propertyLabel) {

       super(keyLabel, module);

       this.preview = preview;
       this.propertyLabel = propertyLabel;

   }

   // ACCESSOR METHODES ...
   public Component getPreview() {
       return preview;
   }
   public JLabel getPropertyLabel() {
       return propertyLabel;
   }

   // MUTATOR METHODES ...
   public void setPreview(Component panel) {
      preview=panel;
   }
   public void setPropertyLabel(JLabel label) {
      propertyLabel = label;
   }
   
   
   
}
