/* leviMenu.java
 * 
 * Created on 11.02.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui;



import java.awt.*;
import java.net.*;

import javax.swing.*;

import learningVisualizations.LeviModule;
import learningVisualizations.gui.actions.LeviAbstractAction;
import learningVisualizations.gui.actions.LeviActionLanguageKonfiguration;
import learningVisualizations.gui.actions.LeviActionSetActiveScenario;
import learningVisualizations.scenario.LeviScenario;
import learningVisualizations.scenario.LeviScenarioInterface;



/**
 * @author sirocic
 *
 * Class: leviMenu
 * 
 * Description: The class "leviMenu" is the general class for a
 * 				menu bar. 
 * 
 * Date:	11.02.2005
 */
public class LeviMenu extends JMenuBar
{
	static final long serialVersionUID=1;
	
	// parent frame
	private static LeviFrame myFrame;
	
	// Menu items
	private LeviSubmenu myMenuScenario;
	private LeviSubmenu myMenuView;
	private LeviSubmenu myMenuEdit;
	private LeviSubmenu myMenuSimulation;
	private LeviSubmenu myMenuConfiguration;
	private LeviSubmenu myMenuHelp;
	private LeviSubmenu mySubmenuLanguage;
	private LeviSubmenu mySubmenuTempo;
	private LeviSubmenu mySubmenuConfigHelp;
	private LeviSubmenu mySubmenuConfigSimulator;
	private LeviSubmenu mySubmenuConfigScenario;
	private LeviButton myButtonLanguageSwitch;
	private LeviActionLanguageKonfiguration actionLanguageSwitch;
	
   /* @author sirocic
    *
    * Methode:	Constructors
    * 
    * Date: 11.02.05
    *
    */
    public LeviMenu()
    {
    	super(); 
    	this.myMenuScenario = new LeviSubmenu();
    	this.myMenuSimulation = new LeviSubmenu();
    	this.myMenuView = new LeviSubmenu();
    	this.myMenuConfiguration = new LeviSubmenu();
    	this.myMenuHelp = new LeviSubmenu();
    	this.myMenuEdit = new LeviSubmenu();
    	this.mySubmenuLanguage = new LeviSubmenu();
    	this.mySubmenuTempo = new LeviSubmenu();
    	this.mySubmenuConfigHelp = new LeviSubmenu();
    	this.mySubmenuConfigSimulator = new LeviSubmenu();
    	this.mySubmenuConfigScenario = new LeviSubmenu();
    	this.myButtonLanguageSwitch = new LeviButton();
    	this.myFrame = null;
    	
    }
    public LeviMenu(LeviFrame myFrame)
    {
	  	super(); 
	  	 	
	  	this.myFrame = myFrame;
	  	
	  	URL iconurl;
	  	
	  	// BUILD SUBMENU "scenario" 
	  	myMenuScenario = new LeviSubmenu(this.myFrame, "menu.scenario");
	  	addToMenuScenario("learningVisualizations.gui.actions.LeviActionOpenScenario", "scenario.open", "key.open", null, null);
	  	addToMenuScenario("learningVisualizations.gui.actions.LeviActionSaveAsScenario", "scenario.saveas", "key.saveas",  null, null);
	  	addToMenuScenario("learningVisualizations.gui.actions.LeviActionNewScenario", "scenario.new", "key.new",  null, null);
	  	addToMenuScenario("learningVisualizations.gui.actions.LeviActionCloseScenario", "scenario.close", "key.close",  null, null);
	  	addToMenuScenario("learningVisualizations.gui.actions.LeviActionQuit", "scenario.quit", "key.quit", null, null);
		this.add(myMenuScenario);
	  	
	  	// BUILD SUBMENU "SIMULATION" 
	  	myMenuSimulation = new LeviSubmenu(this.myFrame,"menu.simulation");
	  	addToMenuSimulation("learningVisualizations.gui.actions.LeviActionPlaySimulation", "sim.play", "key.sim.play",  null, null);
	  	addToMenuSimulation("learningVisualizations.gui.actions.LeviActionForwardSimulation", "sim.forward", "key.sim.forward",  null, null);
	  	addToMenuSimulation("learningVisualizations.gui.actions.LeviActionBackSimulation", "sim.backward", "key.sim.backward", null, null);
	  	addToMenuSimulation("learningVisualizations.gui.actions.LeviActionPauseSimulation", "sim.pause", "key.sim.pause",  null, null);
	  	addToMenuSimulation("learningVisualizations.gui.actions.LeviActionStopSimulation", "sim.stop", "key.sim.stop",  null, null);
	  	mySubmenuTempo = new LeviSubmenu(this.myFrame, "sim.tempo");
	  	addToSubmenuTempo("learningVisualizations.gui.actions.LeviActionChangeTempo", "sim.faster", "key.sim.faster", null, null);
	  	addToSubmenuTempo("learningVisualizations.gui.actions.LeviActionChangeTempo", "sim.slower", "key.sim.slower",  null, null);
	  	addSubmenuToMenuSimulation(mySubmenuTempo);
	  	this.add(myMenuSimulation);
	  	
	 	// BUILD SUBMENU "VIEW" 
	  	myMenuView = new LeviSubmenu(this.myFrame,"menu.viewmode");
	  	addToMenuView("learningVisualizations.gui.actions.LeviActionChangeView", "viewmode.lecture", "key.mode.lecture", null, null);
	  	if (this.myFrame.getLearningModule().getConfiguration().getSettingByKey("Help") != null) {
	  		if ((Boolean) this.myFrame.getLearningModule().getConfiguration().getSettingByKey("Help"))
	  			addToMenuView("learningVisualizations.gui.actions.LeviActionHelpOnOff", "viewmode.help.off", "key.mode.helpoff", null, null);
	  		else
	  			addToMenuView("learningVisualizations.gui.actions.LeviActionHelpOnOff", "viewmode.help.on", "key.mode.helpon", null, null);
	  	}
	  	else if (this.myFrame.getLearningModule().getConfiguration().getSettingByKey("Avatar") != null) {
	  		if ((Boolean) this.myFrame.getLearningModule().getConfiguration().getSettingByKey("Avatar")	)
	  			addToMenuView("learningVisualizations.gui.actions.LeviActionHelpOnOff", "viewmode.help.off", "key.mode.helpoff", null, null);
	  		else
	  			addToMenuView("learningVisualizations.gui.actions.LeviActionHelpOnOff", "viewmode.help.on", "key.mode.helpon", null, null);
	    }
	  	if (this.myFrame.getLearningModule().getConfiguration().getSettingByKey("Tooltips") != null) {
	  		if ((Boolean) this.myFrame.getLearningModule().getConfiguration().getSettingByKey("Tooltips"))
	  			addToMenuView("learningVisualizations.gui.actions.LeviActionTooltipsOnOff", "viewmode.tooltips.off", "key.mode.tooltipsoff", null, null);
	  		else
	  			addToMenuView("learningVisualizations.gui.actions.LeviActionTooltipsOnOff", "viewmode.tooltips.on", "key.mode.tooltipson", null, null);
	  	}
	  	myMenuView.addSeparator();
	  	this.add(myMenuView);
	  	
	  	// BUILD SUBMENU "KONFIGURATION" 
	  	myMenuConfiguration = new LeviSubmenu(this.myFrame,"menu.konfig");
	  	
	  	// Men fr hilfe erzeugen 
	  	// !!! bs 02.05.2008 Weg Avatar -> help wurde der entsprechende XML-Tag auch umbenannt. Damit alte Config-Files weiter funktionieren
	  	//   muss hier auf das alte und neue Tag geprft werden. !!!
	  	mySubmenuConfigHelp = new LeviSubmenu(this.myFrame, "konfig.help");
	  	if (this.myFrame.getLearningModule().getConfiguration().getSettingByKey("Help") != null) {
	  		if ((Boolean) this.myFrame.getLearningModule().getConfiguration().getSettingByKey("Help"))
	  			addToSubmenuHelp("learningVisualizations.gui.actions.LeviActionHelpConfig", "konfig.helpoff", "key.konfig.helpoff",  null, null);
	  		else
	  			addToSubmenuHelp("learningVisualizations.gui.actions.LeviActionHelpConfig", "konfig.helpon", "key.konfig.helpon", null, null);
	  	} 
	  	else if (this.myFrame.getLearningModule().getConfiguration().getSettingByKey("Avatar") != null) {
	  		if ((Boolean) this.myFrame.getLearningModule().getConfiguration().getSettingByKey("Avatar"))
	  			addToSubmenuHelp("learningVisualizations.gui.actions.LeviActionHelpConfig", "konfig.helpoff", "key.konfig.helpoff", null, null);
	  		else
	  			addToSubmenuHelp("learningVisualizations.gui.actions.LeviActionHelpConfig", "konfig.helpon", "key.konfig.helpon", null, null);
	  	}
	  	if (this.myFrame.getLearningModule().getConfiguration().getSettingByKey("Tooltips") != null) {
	  		if ((Boolean) this.myFrame.getLearningModule().getConfiguration().getSettingByKey("Tooltips"))
	  			addToSubmenuHelp("learningVisualizations.gui.actions.LeviActionTooltipsConfig", "konfig.tooltipsoff", "key.konfig.tooltipsoff",  null, null);
	  		else
	  			addToSubmenuHelp("learningVisualizations.gui.actions.LeviActionTooltipsConfig", "konfig.tooltipson", "key.konfig.tooltipson", null, null);
	  	} 
	  	addSubmenuToMenuConfiguration(mySubmenuConfigHelp);
	  	
	  	mySubmenuConfigScenario = new LeviSubmenu(this.myFrame, "konfig.scenario");
	  	addToSubmenuScenario("learningVisualizations.gui.actions.LeviActionSelectDefaultScenario", "konfig.default", "key.default",  null, null);
	  	addSubmenuToMenuConfiguration(mySubmenuConfigScenario);
	  	
	  	mySubmenuConfigSimulator = new LeviSubmenu(this.myFrame, "konfig.sim");
	  	addToSubmenuSimulator("learningVisualizations.gui.actions.LeviActionSaveSleepFactor", "konfig.sleeping", "key.sleeping",  null, null);
	  	addSubmenuToMenuConfiguration(mySubmenuConfigSimulator);
	  	
	  	mySubmenuLanguage = new LeviSubmenu(this.myFrame, "konfig.language");
	  	addToSubmenuLanguage("learningVisualizations.gui.actions.LeviActionLanguageKonfiguration", "konfig.language.de", "key.konfig.language.de",  null, null,"de");
	  	addToSubmenuLanguage("learningVisualizations.gui.actions.LeviActionLanguageKonfiguration", "konfig.language.en", "key.konfig.language.en",  null, null, "en");
	  	addSubmenuToMenuConfiguration(mySubmenuLanguage);
		
	  	addToMenuConfiguration("learningVisualizations.gui.actions.LeviActionColorKonfiguration", "konfig.color", "key.konfig.color", null, null);
	  	addToMenuConfiguration("learningVisualizations.gui.actions.LeviActionFontKonfiguration", "konfig.font", "key.konfig.font", null, null);
	  	this.add(myMenuConfiguration);
	  	
	 	// BUILD SUBMENU "HELP" 
	  	myMenuHelp = new LeviSubmenu(this.myFrame, "menu.help");
	  	addToMenuHelp("learningVisualizations.gui.actions.LeviActionWelcome", "help.welcome", "key.welcome", null, null);
	  	addToMenuHelp("learningVisualizations.gui.actions.LeviActionManual", "help.manual", "key.manual", null, null);
	  	addToMenuHelp("learningVisualizations.gui.actions.LeviActionTutorial", "help.tutorial", "key.tutorial",null, null);
	  	
	  	this.add(myMenuHelp);
		
	    //	 BUILD EMPTY SUBMENU "EDIT" 
		myMenuEdit = new LeviSubmenu(this.myFrame, "menu.edit");
		
		// BUILD THE BUTTON LANGUAGE SWITCH	
	    myButtonLanguageSwitch = new LeviButton("button.language", this.myFrame.getLearningModule());
	    actionLanguageSwitch = new LeviActionLanguageKonfiguration(this.myFrame.getLearningModule());
	    if (this.myFrame.getLearningModule().getLanguage().equals("de"))
	    	actionLanguageSwitch.putValue("LANGUAGE", "en");
	    if (this.myFrame.getLearningModule().getLanguage().equals("en"))
	    	actionLanguageSwitch.putValue("LANGUAGE", "de");
	    myButtonLanguageSwitch.setAction(actionLanguageSwitch);
	    this.add(myButtonLanguageSwitch);
	    
		// Farbe, Tooltips und Font setzen
        setPanelTexte();
        setPanelFont();
        setPanelColors();

  } // End leviMenu(leviFrame parent, Locale loc)

    /**
     * Methode:		updateLanguageColorFonts
     *
     * Description:	Sollte aufgerufen werden, wenn ein Sprach- oder Farbwechsel stattgefunden hat.
     * 				Texte und Icons werden neu aus den Resourcen geladen und die Farbe neu nach den
     * 				aktuellen Werten gesetzt.
     *
     * Parameters:
     *
     * Date: 		24.04.2007
     * @author      sirocic
     */
     public void updateLanguageColorFonts() {
    	 int i;
         Component item;
         
         // TRACE OUTPUT
         if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.updateLanguageColorFonts:");

         //  SUBKOMPONENTE UPDATEN...
         for(i=0; i < this.getComponentCount(); i++) {
             item = this.getComponent(i);
             if (item != null)  {
                // bei den Menueintrgen, die selber Untermens sind, muss upgedatet werden
                if (item instanceof LeviSubmenu)
                    ((LeviSubmenu)item).updateLanguageColorFonts();
             }
         }
         if (this.myFrame.getLearningModule().getLanguage().equals("de"))
        	 myButtonLanguageSwitch.getAction().putValue("LANGUAGE", "en");
 	     if (this.myFrame.getLearningModule().getLanguage().equals("en"))
 	    	myButtonLanguageSwitch.getAction().putValue("LANGUAGE", "de");
         myButtonLanguageSwitch.updateLanguageColorFonts();

         // FARBEN SETZEN ...
     	 setPanelColors();

     	 // FONTS SETZEN ...
         setPanelFont();
         
         // TEXTE SETZEN ...
         setPanelTexte();
     	  
         // TRACE OUTPUT
         if (LeviModule.isTraceActive()) System.out.println("END leviMenu.updateLanguageColorFonts");

     }
     
     /*
      * Methode:		setDialogFont
      * 
      * Description:	Setz alle Hintergrund- und Vordergrundfarben der GUI-Element auf die aktuellen
      * 				Werte. 
      *    
      * Parameters:   Aktuelle Font fr Labels und Textfelder.
      * 
      * Date: 		 23.04.2007
      * @author        sirocic
      */	
     private void setPanelFont() {
    	 Font font;
  	   
    	 font = (Font)myFrame.getLearningModule().getConfiguration().getSettingByKey("FontMenu");
    	   
    	 setFont(font);
  	   	  
     }
     
     /*
      * Methode:		setDialogTexte
      * 
      * Description:	Setz alle Text-Bausteine des Dialoges neu. Wichtig fr Sprachwechsel.
      *    
      * Parameters:   
      * 
      * Date: 		 23.04.2007
      * @author        sirocic
      */	
     private void setPanelTexte() {
	 
     }
     
     /*
      * Methode:		setDialogColors
      * 
      * Description:	Setz alle Hintergrund- und Vordergrundfarben der GUI-Element auf die aktuellen
      * 				Werte. 
      *    
      * Parameters:   Aktuelle Farbwerte fr Hintergrund und Vordergrund.
      * 
      * Date: 		 23.04.2007
      * @author        sirocic
      */	
     private void setPanelColors() {
    	 Color backgroundColor,  foregroundColor;
  	   
  	   if (myFrame.getLearningModule().getConfiguration().getSettingByKey("ColorComponentBackground")!=null) {
  		   backgroundColor = (Color)myFrame.getLearningModule().getConfiguration().getSettingByKey("ColorComponentBackground");
  		   foregroundColor = (Color)myFrame.getLearningModule().getConfiguration().getSettingByKey("ColorComponentForeground");
  	   }
  	   else {
  		   backgroundColor = (Color)myFrame.getLearningModule().getConfiguration().getSettingByKey("ColorModuleBackground");
  		   foregroundColor = (Color)myFrame.getLearningModule().getConfiguration().getSettingByKey("ColorModuleForeground");
  		   
  	   }  
  	   
    	 // 	 Hintergrund und Zeichenfarbe auf aktuelle Werte setzen
         setBackground(backgroundColor);
    	 setForeground(foregroundColor);
    	 
     }
     
    /*
   * Methode:		paintComponent
   * 
   * Description:	Calls the paintComponent methode of the JPanel.
   *    
   * Parameters:    
   * 
   * Date: 		    13.09.2005
   * @author        sirocic
   */	
  public void paintComponent(Graphics g) {
     
	  // TRACE OUTPUT
	  if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.paintComponent:");

	  // here calling the paint methode of the JPanel
	  super.paintComponent(g);

 	  // TRACE OUTPUT
 	  if (LeviModule.isTraceActive()) System.out.println("END leviMenu.paintComponent");

  } 
  
  /*
  *
  * Methode:		createMenuAction
  * 
  * Description:	Creates a new action object for a menu item specified by the parameter. 
  *                 <actionName> is the name of the action class.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public static Action createMenuAction(String actionName, String keyLabel, String keyStroke, Icon icon, String tip)
  {
  	Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.createMenuAction: actionName="+actionName);

	try
	{
		action = (Action) Class.forName(actionName).newInstance();
		action.putValue(Action.NAME, myFrame.getLearningModule().getRessources().getResourceByKey(keyLabel));
		((LeviAbstractAction) action).setLearningModule(myFrame.getLearningModule());
		((LeviAbstractAction) action).setKeyLabel(keyLabel);
		if (myFrame.getLearningModule().getRessources().getResourceByKey(keyStroke).length() != 0) 
		   action.putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke(myFrame.getLearningModule().getRessources().getResourceByKey(keyStroke)));
		if ( icon != null)
        	action.putValue(Action.SMALL_ICON, icon);
        if ( tip != null)
            action.putValue(Action.SHORT_DESCRIPTION, tip);
        
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviMenu.createMenuAction");
	
        return action;

	}
	catch (Exception e)
	{
		System.out.println("Internal Error (leviMenu.createMenuAction):" + e.toString());
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviMenu.createMenuAction with error");
	
		return null;
	}
		
  }
  
  /*
  *
  * Methode:		createMenuScenarioAction
  * 
  * Description:	Creates a new action object for a menu item specified by the parameter. 
  *                 <actionName> is the name of the action class.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  private Action createMenuScenarioAction(String actionName, LeviScenario scenario)
  {
  	Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.createMenuScenarioAction: actionName="+actionName);

	try
	{
		action = (Action) Class.forName(actionName).newInstance();
		action.putValue(Action.NAME, scenario.getName());
		action.putValue("SCENARIO", scenario);
		((LeviAbstractAction) action).setLearningModule(myFrame.getLearningModule());
		((LeviAbstractAction) action).setKeyLabel("");
        action.putValue(Action.SHORT_DESCRIPTION, "");
        
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviMenu.createMenuAction");
	
        return action;

	}
	catch (Exception e)
	{
		System.out.println("Internal Error (leviMenu.createMenuScenarioAction):" + e.toString());
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviMenu.createMenuScenarioAction with error");
	
		return null;
	}
		
  }
  /*
  *
  * Methode:		addSubmenu
  * 
  * Description:	Adds a new submenu to the menu given by the parameter <menu>. 
  *                 The submenu is given by the parameter <submenu>.
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  private void addSubmenu(JMenu menu, JMenu submenu)
  {
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addSubmenu: menu="+menu.getName());
	
	menu.add(submenu);

	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addSubmenu");
	
  }
  
  // !!!!
  // scenario MENU
  
  public JMenu getMenuScenario()
  {
  	return myMenuScenario;
  }
  public void setMenuScenario(LeviSubmenu menuScenario)
  {
  	 myMenuScenario=menuScenario;
  }
  public void addMenuScenario()
  {
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addMenuScenario:");

  	this.add(myMenuScenario); 
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addMenuScenario");
	
  }    
  /*
  *
  * Methode:		setMenuScenarioLabel
  * 
  * Description:	Set the label of the Scenario menu to the given string <newName>.
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void setMenuScenarioLabel(String newName)
  {
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.setMenuScenarioLabel: newName="+newName);
	
  	myMenuScenario.setText(newName);
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.setMenuScenarioLabel");
	
  }
  
  /*
  *
  * Methode:		addToMenuScenario
  * 
  * Description:	Adds a new item to the Scenario menu. The menu item will execute the action given by <actionName>.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void addToMenuScenario(String actionName, String keyLabel, String keyStroke, Icon icon, String tip)
  {
  	Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToMenuScenario: actionName="+actionName);

    action = createMenuAction(actionName, keyLabel, keyStroke, icon, tip);

    if (action != null) 
		// append to the Scenario menu 
		myMenuScenario.add(action);

  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToMenuScenario");
	
  }
  
  /*
  *
  * Methode:		addSubmenuToMenuScenario
  * 
  * Description:	Adds a new submenu to the Scenario menu. The submenu is given by the parameter <submenu>
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void addSubmenuToMenuScenario(JMenu submenu)
  {  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addSubmenuToMenuScenario: submenu="+submenu.getName());
	
	addSubmenu(myMenuScenario, submenu);
	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addSubmenuToMenuScenario");
  }
  
  
  // !!!!!
  // VIEW MENU
  
  public JMenu getMenuView()
  {
  	return myMenuView;
  }
  public void setMenuView(LeviSubmenu menu)
  {
	  myMenuView=menu;
  }
  public void addMenuView()
  {
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addMenuView:");

  	this.add(myMenuView); 
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addMenuView");
	
  }    
  /*
  *
  * Methode:		addToMenuView
  * 
  * Description:	Adds a new item to the view menu. The menu item will execute the action given by <actionName>.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void addToMenuView(String actionName, String keyLabel, String keyStroke, Icon icon, String tip)
  {
    Action action;
    JMenuItem item;
    int i;
    boolean trennlinie;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToMenuView: actionName="+actionName);

    action = createMenuAction(actionName, keyLabel, keyStroke, icon, tip);

    if (action != null) {
		// append to the Scenario menu 
    	// Da der neue eintrag kein Szenario ist, muss er vor der 
    	// Trennlinie eingefgt werden.
    	i=0;
    	trennlinie=false;
    	while ( (!trennlinie) && (i < myMenuView.getItemCount())) {
            item = myMenuView.getItem(i);
            if (item != null) {
            	if (item.getAction()==null)
            		trennlinie=true;
            }
            i++;
        }
    	if (trennlinie) {
    		item = new JMenuItem();
    		item.setAction(action);
    		myMenuView.add(item, i);
    	}
    	else
    		myMenuView.add(action);
    }

	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToMenuView");
	
  }
  
  /*
  *
  * Methode:		addSubmenuToMenuView
  * 
  * Description:	Adds a new submenu to the view menu. The submenu is given by the parameter <submenu>
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void addSubmenuToMenuView(JMenu submenu)
  {
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addSubmenuToMenuView: submenu="+submenu.getName());
	
	addSubmenu(myMenuView, submenu);
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addSubmenuToMenuView");
  }

  /*
  *
  * Methode:		addToScenarioView
  * 
  * Description:	Adds a new item for a scenario in the view menu. 
  * 				The relevant scenario is given by the parameter.
  * Date: 		    15.05.2006
  * @author         sirocic
  */
  public void addToScenarioView(LeviScenario scenario)
  {
    Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToScenarioView: scenarioName="+scenario.getName());

    action = createMenuScenarioAction("learningVisualizations.gui.actions.LeviActionSetActiveScenario",scenario);

    if (action != null) 
		// append to the Scenario menu 
    	myMenuView.add(action);
	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToScenarioView");
	
  }
  
  /*
  *
  * Methode:		removeFromScenarioView
  * 
  * Description:	Removes the item for the givven scenario from the view menu. 
  * 				The relevant scenario is given by the parameter.
  * Date: 		    15.05.2006
  * @author         sirocic
  */
  public void removeFromScenarioView(LeviScenarioInterface scenario)
  {
  	int i;
  	JMenuItem item;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToScenarioView: scenarioName="+scenario.getName());

	if (myMenuView.getItemCount() > 0) {
		i=0;
		while (i < myMenuView.getItemCount()) {
	        item = myMenuView.getItem(i);
	        if ((item!=null)&& (item.getText()!=null)){
	        	if (item.getText().equals(scenario.getName()))
	    			myMenuView.remove(item);
	        }
	        i++;
	    }
	}
	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToScenarioView");
	
  }
  
  /*
  *
  * Methode:		updateViewMenu
  * 
  * Description:	Updates the menu view. All scenarios are enable
  * 				but not the current shown one.
  * 
  * Date: 		    15.05.2006
  * @author         sirocic
  */
  public void updateViewMenu()
  {
	  int i;
      JMenuItem item;
      LeviScenario itemScenario;
      
      // TRACE OUTPUT
      if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.updateViewMenu:");

      //  ITEMS UPDATEN...
      for(i=0; i < myMenuView.getItemCount(); i++) {
          item = myMenuView.getItem(i);
          if (item != null)  {
             if (item.getAction() instanceof LeviActionSetActiveScenario) {
            	 itemScenario = (LeviScenario) item.getAction().getValue("SCENARIO");
            	 item.setText(itemScenario.getName());
            	 if(myFrame.getLearningModule().getScenario().getName().equals(itemScenario.getName())) {
            		 item.setEnabled(false);
                 } else {
                	 item.setEnabled(true);
                 }
             }
          }
      }
      
    // TRACE OUTPUT
  	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.updateViewMenu");
  	
  }
  
  // !!!!
  // EDIT MENU
  
  public JMenu getMenuEdit()
  {
  	return myMenuEdit;
  }
  public void setMenuEdit(LeviSubmenu menu)
  {
	  myMenuEdit=menu;
  }
  public void addMenuEdit()
  {
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addMenuEdit:");

  	this.add(myMenuEdit); 
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addMenuEdit");
	
  }
  
  public void addMenuEdit(String label, int position)
  {
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addMenuEdit: label="+label+" position="+position);
	
	this.remove(myMenuEdit);
  	this.add(myMenuEdit, position); 

	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addMenuEdit");
	
  }
  public void addMenuHelp(int position)
  {
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addMenuHelp: position="+position);
	
  	this.add(myMenuHelp, position); 

	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addMenuHelp");
	
  }
  
  /*
  *
  * Methode:		addToMenuEdit
  * 
  * Description:	Adds a new item to the edit menu. The menu item will execute the action given by <actionName>.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void addToMenuEdit(String actionName, String keyLabel, String keyStroke, Icon icon, String tip)
  {
    Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToMenuEdit: actionName="+actionName);

    action = createMenuAction(actionName, keyLabel, keyStroke, icon, tip);

    if (action != null) 
		// append to the Scenario menu 
		myMenuEdit.add(action);

 	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToMenuEdit");
	
  }
  
  /*
  *
  * Methode:		addSubmenuToMenuEdit
  * 
  * Description:	Adds a new submenu to the Scenario menu. The submenu is given by the parameter <submenu>
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void addSubmenuToMenuEdit(JMenu submenu)
  {
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addSubmenuToMenuEdit: submenu="+submenu.getName()+
			                              "background="+submenu.getBackground().toString());
	
	addSubmenu(myMenuEdit,submenu);

	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addSubmenuToMenuEdit  background="+submenu.getBackground().toString());
	
  }

  // !!!!
  // SIMULATION MENU
  
  public JMenu getMenuSimulation()
  {
  	return myMenuSimulation;
  }
  public void setMenuSimulation(LeviSubmenu menu)
  {
	  myMenuSimulation=menu;
  }
  public void addMenuSimulation()
  {
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addMenuSimulation:");

  	this.add(myMenuSimulation); 
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addMenuSimulation");
	
  }  
  /*
  *
  * Methode:		addToMenuSimulation
  * 
  * Description:	Adds a new item to the simulation menu. The menu item will execute the action given by <actionName>.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void addToMenuSimulation(String actionName, String keyLabel, String keyStroke, Icon icon, String tip)
  {
    Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToMenuSimulation: actionName="+actionName);

    action = createMenuAction(actionName, keyLabel, keyStroke, icon, tip);

    if (action != null) 
		// append to the Scenario menu 
		myMenuSimulation.add(action);

	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToMenuSimulation");
	
  }
  
  /*
  *
  * Methode:		addSubmenuToMenuSimulation
  * 
  * Description:	Adds a new submenu to the Scenario menu. The submenu is given by the parameter <submenu>
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void addSubmenuToMenuSimulation(JMenu submenu)
  {
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addSubmenuToMenuSimulation: submenu="+submenu.getName());
	
	addSubmenu(myMenuSimulation,submenu);
	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addSubmenuToMenuSimulation");
	
  }
  
  /*
  *
  * Methode:		addToSubmenuTempo
  * 
  * Description:	Adds a new item to the submenu Tempo. The menu item will execute the action given by <actionName>.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  *                 The parameter <language> contains the information about the language which will be
  *                 set by this action. 
  * 
  * Date: 		    15.05.2006
  * @author         sirocic
  */
  public void addToSubmenuTempo(String actionName, String keyLabel, String keyStroke, Icon icon, String tip)
  {
    Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToSubmenuTempo: actionName="+actionName);

    action = createMenuAction(actionName, keyLabel, keyStroke, icon, tip);

    if (action != null) 
		// append to the Scenario menu 
		mySubmenuTempo.add(action);
	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToSubmenuTempo");
	
  }
  
  // !!!!!
  //KONFIGURATION MENU
  
  public JMenu getMenuConfiguration()
  {
  	return myMenuConfiguration;
  }
  public LeviSubmenu getSubmenuLanguage()
  {
  	return mySubmenuLanguage;
  }
  public void setMenuConfiguration(LeviSubmenu menu)
  {
	  myMenuConfiguration=menu;
  }
  public void addMenuConfiguration()
  {
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.setMenuConfiguration:");

  	this.add(myMenuConfiguration); 
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.setMenuConfiguration");
	
  }  
  public void setSubmenuLanguage(LeviSubmenu menu)
  {
	  mySubmenuLanguage=menu;
  }
  public void addSubmenuLanguage()
  {
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.setMenuConfiguration:");

  	myMenuConfiguration.add(mySubmenuLanguage); 
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addMenuSimulation");
	
  }  
  /*
  *
  * Methode:		addToMenuConfiguration
  * 
  * Description:	Adds a new item to the configuration menu. The menu item will execute the action given by <actionName>.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void addToMenuConfiguration(String actionName, String keyLabel, String keyStroke, Icon icon, String tip)
  {
    Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToMenuConfiguration: actionName="+actionName);

    action = createMenuAction(actionName, keyLabel, keyStroke, icon, tip);

    if (action != null) 
		// append to the Scenario menu 
		myMenuConfiguration.add(action);
	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToMenuKonfiguration");
	
  }
  
  /*
  *
  * Methode:		addSubmenuToMenuConfiguration
  * 
  * Description:	Adds a new submenu to the Scenario menu. The submenu is given by the parameter <submenu>
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void addSubmenuToMenuConfiguration(JMenu submenu)
  {
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addSubmenuToMenuKonfiguration: submenu="+submenu.getName());
	
	addSubmenu(myMenuConfiguration,submenu);
	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addSubmenuToMenuKonfiguration");
	
  }
  
  /*
  *
  * Methode:		addToSubmenuLanguage
  * 
  * Description:	Adds a new item to the submenu Language. The menu item will execute the action given by <actionName>.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  *                 The parameter <language> contains the information about the language which will be
  *                 set by this action. 
  * 
  * Date: 		    24.04.2006
  * @author         sirocic
  */
  public void addToSubmenuLanguage(String actionName, String keyLabel, String keyStroke, Icon icon, String tip, String language)
  {
    Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToSubmenuLanguage: actionName="+actionName);

    action = createMenuAction(actionName, keyLabel, keyStroke, icon, tip);
    action.putValue("LANGUAGE", language);

    if (action != null) 
		// append to the Scenario menu 
		mySubmenuLanguage.add(action);
	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToSubmenuLanguage");
	
  }
  /*
  *
  * Methode:		addToSubmenuHelp
  * 
  * Description:	Adds a new item to the submenu Help in the configuration menu. The menu item will execute the action given by <actionName>.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  * 
  * Date: 		    18.05.2006
  * @author         sirocic
  */
  public void addToSubmenuHelp(String actionName, String keyLabel, String keyStroke, Icon icon, String tip)
  {
    Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToSubmenuHelp: actionName="+actionName);

    action = createMenuAction(actionName, keyLabel, keyStroke, icon, tip);

    if (action != null) 
		// append to the Scenario menu 
    	mySubmenuConfigHelp.add(action);
	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToSubmenuHelp");
	
  }
  /*
  *
  * Methode:		addToSubmenuScenario
  * 
  * Description:	Adds a new item to the submenu Scenario in the configuration menu. The menu item will execute the action given by <actionName>.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  * 
  * Date: 		    18.05.2006
  * @author         sirocic
  */
  public void addToSubmenuScenario(String actionName, String keyLabel, String keyStroke, Icon icon, String tip)
  {
    Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToSubmenuScenario: actionName="+actionName);

    action = createMenuAction(actionName, keyLabel, keyStroke, icon, tip);

    if (action != null) 
		// append to the Scenario menu 
    	mySubmenuConfigScenario.add(action);
	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToSubmenuScenario");
	
  }
  /*
  *
  * Methode:		addToSubmenuSimulator
  * 
  * Description:	Adds a new item to the submenu Scenario in the configuration menu. The menu item will execute the action given by <actionName>.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  * 
  * Date: 		    18.05.2006
  * @author         sirocic
  */
  public void addToSubmenuSimulator(String actionName, String keyLabel, String keyStroke, Icon icon, String tip)
  {
    Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToSubmenuSimulator: actionName="+actionName);

    action = createMenuAction(actionName, keyLabel, keyStroke, icon, tip);

    if (action != null) 
		// append to the Scenario menu 
    	mySubmenuConfigSimulator.add(action);
	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToSubmenuSimulator");
	
  }
  
  // !!!!
  //    HELP MENU
  
  public JMenu getMenuHelp()
  {
  	return myMenuHelp;
  }
  public void setMenuHelp(LeviSubmenu menu)
  {
	  myMenuHelp=menu;
  }
  public void addMenuHelp()
  {
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addMenuHelp:");

  	this.add(myMenuHelp); 

	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addMenuHelp");
	
  }    
  /*
  *
  * Methode:		addToMenuHelp
  * 
  * Description:	Adds a new item to the help menu. The menu item will execute the action given by <actionName>.
  *                 <keyLabel> is the ressource key of the new menu item label. <keyStroke> is the
  *                 ressource key of the accelerator key. <inputEvent> is the integer code of the event. 
  *                 <icon> is the icon which will be displayed next to the menu item and <tip> is the tool tip
  *                 of the new menu item.
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void addToMenuHelp(String actionName, String keyLabel, String keyStroke, Icon icon, String tip)
  {
    Action action;
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addToMenuHelp: actionName="+actionName);

    action = createMenuAction(actionName, keyLabel, keyStroke, icon, tip);

    if (action != null) 
		// append to the Scenario menu 
		myMenuHelp.add(action);


	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addToMenuHelp");
	
  }
  
  /*
  *
  * Methode:		addSubmenuToMenuHelp
  * 
  * Description:	Adds a new submenu to the Scenario menu. The submenu is given by the parameter <submenu>
  * 
  * Date: 		    29.08.2005
  * @author         sirocic
  */
  public void addSubmenuToMenuHelp(JMenu submenu)
  {
  	
	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("CALL leviMenu.addSubmenuToMenuHelp: submenu="+submenu.getName());
	
	addSubmenu(myMenuHelp,submenu);

	// TRACE OUTPUT
	if (LeviModule.isTraceActive()) System.out.println("END leviMenu.addSubmenuToMenuHelp");
	
  }
  
  
  
}

