/* leviPopupListener.java
 * 
 * Created on 12.05.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui;

import java.awt.event.*;

import learningVisualizations.LeviModule;



/**
 * @author sirocic
 *
 * Class: leviPopupListener
 * 
 * Description: The class "leviPopupListener" is the general class for
 * 				popup menu handling. 
 * 
 * Date:	12.05.2005
 */
public class LeviPopupListener extends MouseAdapter {
	
	private LeviPopup popup;
	
   /*
    * @author sirocic
    *
    * Methode:		Contructors
    * 
    * Description:	Reading the configuration file and the general resources. 
    *				Setting the feature like title, language etc. to the values
    *				readed from the configuration and resources, respectively.
    * 				Building the gui elements of the general learning module. 
    * 
    * Date: 		12.05.2005
    */
    public LeviPopupListener() {
	   	super();
	   	this.popup = null;
    }
    public LeviPopupListener(LeviPopup popup) {
	   	super();
	   	this.popup = popup;
    }
	   
    public void mousePressed(MouseEvent e) {
    	
    	// TRACE OUTPUT
    	if (LeviModule.isTraceActive()) System.out.println("CALL leviPopupListener.mousePressed: e="+e.toString());

        maybeShowPopup(e);
        
       	// TRACE OUTPUT
    	if (LeviModule.isTraceActive()) System.out.println("End leviPopupListener.mousePressed");

    }

    public void mouseReleased(MouseEvent e) {
    	
    	// TRACE OUTPUT
    	if (LeviModule.isTraceActive()) System.out.println("CALL leviPopupListener.mouseReleased: e="+e.toString());

        maybeShowPopup(e);
        
       	// TRACE OUTPUT
    	if (LeviModule.isTraceActive()) System.out.println("End leviPopupListener.mouseReleased");

    }

    /*
     * @author sirocic
     *
     * Methode:		maybeShowPopup
     * 
     * Description:	Showing the popup menu if the right mouse key was pressed. 
     * 
     * Date: 		12.05.2005
     */
    private void maybeShowPopup(MouseEvent e) {
    	
    	// TRACE OUTPUT
    	if (LeviModule.isTraceActive()) System.out.println("CALL leviPopupListener.maybeShowPopup: e="+e.toString());

        if (e.isPopupTrigger()) {
            popup.show(e.getComponent(),
                       e.getX(), e.getY());
        }
        
       	// TRACE OUTPUT
    	if (LeviModule.isTraceActive()) System.out.println("End leviPopupListener.maybeShowPopup");

    }
    
    
}
