/* leviActionCancelDialog.java
 * 
 * Created on 10.04.2006
 * @author sirocic
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;

import learningVisualizations.LeviModule;
import learningVisualizations.gui.LeviDialog;




/**
 * @author sirocic
 *
 * Class: leviActionCancelDialog
 * 
 * Description: The class "leviActionCancelDialog" is the class which realizes the function of
 * 				the button "Cancel" in levi dialogs.
 * 
 * Date:	1.04.2006
 */
public class LeviActionCancelDialog extends LeviAbstractAction
{
	static final long serialVersionUID=1;
	
	protected LeviDialog myDialog;

	//	 Constructors
	public LeviActionCancelDialog()
	{
		// Is needed for the instantiation in the class leviMenu!!
		myDialog= null;
		this.setLearningModule(null);
	}
	public LeviActionCancelDialog(LeviDialog myDialog)
	{
		this.myDialog = myDialog;
		this.setLearningModule(null);
	}

	// END	 Constructors
	
   /*
    * @author sirocic
    *
    * Methode:		actionPerformed
    * 
    * Description:	This method deletes the selected Substep. 
    * 
    * Date: 		10.04.2006
    */
	public void actionPerformed(ActionEvent event)
	{

		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionCancelDialog.actionPerformed: event="+event.toString());
		
		// just close the dialog !!!
		myDialog.showDialog(false);
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionCancelDialog.actionPerformed");

	}
		
}
