/* leviActionChangeTempo.java
 * 
 * Created on 15.05.2006
 * @author sirocic
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;
import javax.swing.*;

import learningVisualizations.LeviModule;



/**
 * @author sirocic
 *
 * Class: leviActionChangeTempo
 * 
 * Description: The class "leviActionChangeTempo" is the class which realizes the function of
 * 				the menu item and the button "Faster simulation", respectively.
 * 
 * Date:	15.05.2006
 */
public class LeviActionChangeTempo extends LeviAbstractAction
{
	static final long serialVersionUID=1;
	
	private String tempoDirection;

	//	 Constructors
	public LeviActionChangeTempo()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionChangeTempo(String keyLabel)
	{
		// Is needed for the instantiation in the class leviMenu!!
		this.setKeyLabel(keyLabel);
	}
	public LeviActionChangeTempo(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionChangeTempo(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionChangeTempo(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	// END	 Constructors
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Faster Simulation". 
   * 
   * Date: 		15.05.2006
   */		
	public void actionPerformed(ActionEvent event)
	{
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionChangeTempo.actionPerformed: event="+event.toString());
		
		tempoDirection = (String) getKeyLabel();
		if (tempoDirection.endsWith("faster"))
			// Simulation beschleunigen um einen Schritt
			this.getLearningModule().getSimulator().speedupSimulation();
		else if (tempoDirection.endsWith("slower"))
			// Simulation verlangsamen um einen Schritt
			this.getLearningModule().getSimulator().slowdownSimulation();
	   

		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionChangeTempo.actionPerformed");

	}
}
