/* leviActionChangeView.java
 * 
 * Created on 17.03.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui.actions;


import java.awt.event.ActionEvent;

import javax.swing.*;

import learningVisualizations.LeviModule;




/**
 * @author sirocic
 *
 * Class: leviActionChangeView
 * 
 * Description: The class "leviActionChangeView" is the class which realizes the function of
 * 				the menu item and the button "Lecture Mode on", respectively.
 * 
 * Date:	17.03.2005
 */
public class LeviActionChangeView extends LeviAbstractAction
{
	static final long serialVersionUID=1;

	//	 Constructors
	public LeviActionChangeView()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionChangeView(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionChangeView(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionChangeView(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	// END	 Constructors
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Lecture Mode on". 
   * 
   * Date: 		17.03.2005
   */			
	public void actionPerformed(ActionEvent event)
	{
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionChangeView.actionPerformed: event="+event.toString());
		
		if (getLearningModule().getView() == LeviModule.SELFSTUDYVIEW) {
			// In die Vorlesungssicht umschalten ...
	        if ((getLearningModule().getScenario() != null) && getLearningModule().getScenario().hasChanged())
	        	// Szenarioanzeige im Visualizer aktualisieren..
	            getLearningModule().getVisualizer().getScenarioVisualizer().createGraphicScenario();
	
			 getLearningModule().setView(LeviModule.LECTUREVIEW);
		}
		else {
			// In die Selbststudiumssicht umschalten..
			//	die Ansicht ndern.
			getLearningModule().setView(LeviModule.SELFSTUDYVIEW);
			
			
			// Wenn die Simulation gestoppt ist. Dann in der Selbststudiumssicht wieder in den Editormodus wechseln.
			if ( getLearningModule().getSimulator().isStop()) {
				// set the module back in the edit mode
				 getLearningModule().setMode(LeviModule.EDITORMODE);
				 getLearningModule().getFrame().changeMode();
			}

		}
		
		getLearningModule().getFrame().changeView();
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionChangeView.actionPerformed");
		
	}
}