/* leviActionCheckScenario.java
 * 
 * Created on 18.03.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui.actions;

import java.awt.event.*;
import javax.swing.*;

import learningVisualizations.LeviModule;




/**
 * @author sirocic
 *
 * Class: leviActionCheckScenario
 * 
 * Description: The class "leviActionCheckScenario" is the class which realizes the function of
 * 				the menu item and the button "Check Scenario", respectively.
 * 
 * Date:	18.03.2005
 */
public class LeviActionCheckScenario extends LeviAbstractAction
{
	static final long serialVersionUID=1;

	//	 Constructors
	public LeviActionCheckScenario()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionCheckScenario(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionCheckScenario(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionCheckScenario(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	// END	 Constructors
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Check Scenario". 
   * 
   * Date: 		18.03.2005
   */	
	public void actionPerformed(ActionEvent event)
	{
		boolean result;
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionCheckScenario.actionPerformed: event="+event.toString());

		result = getLearningModule().getScenario().checkScenario();
		
		if (result) {
			// berprfung war ok. Dies dem Benutzer mitteilen.
			// Bei Fehlern hat er das schon vorher erfahren aus checkScenario heraus.
			getLearningModule().getFrame().showInfoMessageDialog("dlg.scenariooktext");
			
		}
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionCheckScenario.actionPerformed");

	}
}



