/* leviActionColorKonfiguration.java
 * 
 * Created on 04.03.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;
import javax.swing.*;

import learningVisualizations.LeviModule;




/**
 * @author sirocic
 *
 * Class: leviActionColorKonfiguration
 * 
 * Description: The class "leviActionColorKonfiguration" is the class which realizes the function of
 * 				the menu item and the button "Set Colors", respectively.
 * 
 * Date:	04.03.2005
 */
public class LeviActionColorKonfiguration extends LeviAbstractAction
{
	static final long serialVersionUID=1;

	//	 Constructors
	public LeviActionColorKonfiguration()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionColorKonfiguration(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionColorKonfiguration(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionColorKonfiguration(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	// END	 Constructors
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Set Colors". 
   * 
   * Date: 		04.03.2005
   */	
	public void actionPerformed(ActionEvent event)
	{
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionColorKonfiguration.actionPerformed: event="+event.toString());

		getLearningModule().getColorConfigDialog().showDialog(true);
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionColorKonfiguration.actionPerformed");

	}
}

