/* LeviActionDeleteObject.java
 * 
 * Created on 18.03.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;
import javax.swing.*;

import learningVisualizations.LeviModule;




/**
 * @author sirocic
 *
 * Class: LeviActionDeleteObject
 * 
 * Description: The class "LeviActionDeleteObject" provides the action for the
 * 				menu item "delete object".
 * 
 * Date:	18.03.2005
 */
public class LeviActionDeleteObject extends LeviAbstractAction
{
	static final long serialVersionUID=1;

	/* @author sirocic
    *
    * Methode:	Constructors
    * 
    * Date: 18.03.2005
    *
    */
	public LeviActionDeleteObject()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionDeleteObject(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionDeleteObject(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionDeleteObject(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	This method contains the actions which will take place by
   * 				selecting the menu "delete object". 
   * 
   * Date: 		18.03.2005
   */
	public void actionPerformed(ActionEvent event)
	{
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL LeviActionDeleteObject.actionPerformed: event="+event.toString());

		getLearningModule().getEditor().getScenarioEditor().removeSelectedObject();
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END LeviActionDeleteObject.actionPerformed");

	}
	
	
}



