/* leviActionFontKonfiguration.java
 * 
 * Created on 22.06.2007
 * @author sirocic
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;
import javax.swing.*;

import learningVisualizations.LeviModule;




/**
 * @author sirocic
 *
 * Class: leviActionColorKonfiguration
 * 
 * Description: Die Klasse realisiert die Funktion fr den Menueeintrag Einstellungen -> Fonts... .
 * 
 * Date:	22.06.2007
 */
public class LeviActionFontKonfiguration extends LeviAbstractAction
{
	static final long serialVersionUID=1;

	//	 Constructors
	public LeviActionFontKonfiguration()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionFontKonfiguration(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionFontKonfiguration(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionFontKonfiguration(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	// END	 Constructors
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Fonts ...". 
   * 
   * Date: 		22.06.2007
   */	
	public void actionPerformed(ActionEvent event)
	{
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionFontKonfiguration.actionPerformed: event="+event.toString());

		getLearningModule().getFontConfigDialog().showDialog(true);
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionFontKonfiguration.actionPerformed");

	}
}

