/* leviActionHelpConfig.java
 * 
 * Created on 27.04.2006
 * @author sirocic
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.KeyStroke;

import learningVisualizations.LeviModule;



/**
 * @author sirocic
 *
 * Class: leviActionHelpConfig
 * 
 * Description: The class "leviActionHelpConfig" is the class which stores the help settings
 * 				in the configuration. That means, the user can decide if the help should be
 * 				visible or unvisible after the start of the module.
 * 
 * Date:	27.04.2006
 */
public class LeviActionHelpConfig extends LeviAbstractAction
{
	static final long serialVersionUID=1;
	
	//	 Constructors
	public LeviActionHelpConfig()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionHelpConfig(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionHelpConfig(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionHelpConfig(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	//	 END	 Constructors
	
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Help on/off". 
   * 
   * Date: 		29.06.2005
   */
	public void actionPerformed(ActionEvent event)
	{
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionHelpOnOff.actionPerformed: event="+event.toString());		
		
		// update the new value in the configuration
		if (getKeyLabel().endsWith("on")) {
			// Help soll standardmig sichtbar sein !!!
			getLearningModule().getConfiguration().putSettingByKey("Help",true);
			// Menu-Item fr das Anzeigen der Hilfe anpassen ...
            getLearningModule().getFrame().changeItemText(
            getLearningModule().getFrame().getMenubar().getMenuConfiguration(),"konfig.helpon","konfig.helpoff");
            setKeyLabel("konfig.helpoff");
		}
		else if (getKeyLabel().endsWith("off")) {
			getLearningModule().getConfiguration().putSettingByKey("Help",false);
			// Menu-Item fr das Anzeigen der Hilfe anpassen ...
            getLearningModule().getFrame().changeItemText(
            getLearningModule().getFrame().getMenubar().getMenuConfiguration(),"konfig.helpoff","konfig.helpon");
            setKeyLabel("konfig.helpon");
		}
		
		// Abspeichern der Konfiguration
		getLearningModule().getConfiguration().saveConfiguration();
	
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionHelpOnOff.actionPerformed");

	}
}
