/* leviActionHelpOnOff.java
 * 
 * Created on 31.03.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.*;

import learningVisualizations.LeviModule;



/**
 * @author sirocic
 *
 * Class: leviActionHelpOnOff
 * 
 * Description: The class "leviActionHelpOnOff" is the class which realizes the function of
 * 				the menu item "Help on/off".
 * 
 * Date:	03.03.2005
 */
public class LeviActionHelpOnOff extends LeviAbstractAction
{
	static final long serialVersionUID=1;
	
	//	 Constructors
	public LeviActionHelpOnOff()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionHelpOnOff(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionHelpOnOff(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionHelpOnOff(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	//	 END	 Constructors
	
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Help on/off". 
   * 
   * Date: 		29.06.2005
   */
	public void actionPerformed(ActionEvent event)
	{
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionHelpOnOff.actionPerformed: event="+event.toString());		
		
		if (getLearningModule().isHelpVisible()) {
			getLearningModule().setHelpVisible(false);
			
			// Menu-Item fr das Anzeigen der Hilfe anpassen ...
            getLearningModule().getFrame().changeItemText(
            getLearningModule().getFrame().getMenubar().getMenuView(),"viewmode.help.off","viewmode.help.on");
		}
		else {
			getLearningModule().setHelpVisible(true);
			
			// Menu-Item fr das Anzeigen der Hilfe anpassen ...
            getLearningModule().getFrame().changeItemText(
            getLearningModule().getFrame().getMenubar().getMenuView(),"viewmode.help.on","viewmode.help.off");
		}

		getLearningModule().getFrame().composeFrame();
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionHelpOnOff.actionPerformed");

	}
}
