/* leviActionLnfKonfiguration.java
 * 
 * Created on 04.03.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.*;

import learningVisualizations.LeviModule;



/**
 * @author sirocic
 *
 * Class: leviActionLnfKonfiguration
 * 
 * Description: The class "leviActionLnfKonfiguration" is the class which realizes the function of
 * 				the menu item and the button "set look&leel", respectively.
 * 
 * Date:	04.03.2005
 */
public class LeviActionLnfKonfiguration extends LeviAbstractAction
{
	static final long serialVersionUID=1;

	//	 Constructors
	public LeviActionLnfKonfiguration()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionLnfKonfiguration(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionLnfKonfiguration(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionLnfKonfiguration(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	// END	 Constructors
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Set Look&Feel". 
   * 
   * Date: 		04.03.2005
   */			
	public void actionPerformed(ActionEvent event)
	{
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionLnfKonfiguration.actionPerformed: event="+event.toString());

		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionLnfKonfiguration.actionPerformed");

	}
}


