/* leviActionManual.java
 * 
 * Created on 03.03.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;
import javax.swing.*;

import learningVisualizations.LeviModule;




/**
 * @author sirocic
 *
 * Class: leviActionManual
 * 
 * Description: The class "leviActionManual" is the class which realizes the function of
 * 				the menu item and the button "Help", respectively.
 * 
 * Date:	03.03.2005
 */
public class LeviActionManual extends LeviAbstractAction
{
	static final long serialVersionUID=1;

	//	 Constructors
	public LeviActionManual()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionManual(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionManual(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionManual(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	// END	 Constructors
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Help". 
   * 
   * Date: 		03.03.2005
   */		
	public void actionPerformed(ActionEvent event)
	{
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionTutorial.actionPerformed: event="+event.toString());
	
		getLearningModule().getHelp().setNewContent("einfuehrung.html");
		
		if (!getLearningModule().isHelpVisible()) {
			getLearningModule().setHelpVisible(true);
			
			//	Menu-Item fr das Anzeigen der Hilfe anpassen ...
            getLearningModule().getFrame().changeItemText(
            getLearningModule().getFrame().getMenubar().getMenuView(),"viewmode.help.on","viewmode.help.off");
            
			getLearningModule().getFrame().composeFrame();
		}
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionTutorial.actionPerformed");

	}
}
