/* leviActionPlaySimulation.java
 *
 * Created on 03.03.2005
 * Autor: Birgit Sirocic
 *
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;
import javax.swing.*;

import learningVisualizations.LeviModule;
import learningVisualizations.scenario.LeviScenario;
import learningVisualizations.scenario.LeviScenarioInterface;



/**
 * @author sirocic
 *
 * Class: leviActionPlaySimulation
 *
 * Description: The class "leviActionPlaySimulation" is the class which realizes the function of
 * 				the menu item and the button "Play", respectively.
 *
 * Date:	03.03.2005
 */
public class LeviActionPlaySimulation extends LeviAbstractAction
{
    static final long serialVersionUID=1;

    //	 Constructors
    public LeviActionPlaySimulation()
    {
        // Is needed for the instantiation in the class leviMenu!!
    }
    public LeviActionPlaySimulation(LeviModule learningModule, String name)
    {
        putValue(Action.NAME, name);
        setLearningModule(learningModule);
    }
    public LeviActionPlaySimulation(LeviModule learningModule, String name, Icon icon, String tip)
    {
        putValue(Action.NAME, name);
        putValue(Action.SMALL_ICON, icon);
        putValue(Action.SHORT_DESCRIPTION, tip);
        setLearningModule(learningModule);
    }
    public LeviActionPlaySimulation(LeviModule learningModule, String name, KeyStroke acc)
    {
        putValue(Action.NAME, name);
        putValue(Action.ACCELERATOR_KEY, acc);
        setLearningModule(learningModule);
    }
    // END	 Constructors

  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   *
   * Description:	Realizing the function of the menu item or button "Play".
   *
   * Date: 		03.03.2005
   */
    public void actionPerformed(ActionEvent event)
    {
        // TRACE OUTPUT
        if (LeviModule.isTraceActive()) System.out.println("CALL leviActionPlaySimulation.actionPerformed: event="+event.toString());

        // Is there a open and correct scenario?
        LeviScenarioInterface scenario = getLearningModule().getScenario();
        // DF 20060516: check if the scenario is null
        if ((scenario != null) && scenario.isOpen()&& scenario.isOk()) {

        	setActiveAction(this, getLearningModule().getVisualizer().getToolbar().getButtonByKey("button.play"));
        	 
        	// Szenarioanzeige im Visualizer aktualisieren, false sich das scenario verndert hat
            // oder die Anzeig im Visualizer resetet werden muss.
        	if (getLearningModule().getVisualizer().getScenarioVisualizer()!=null)
        		getLearningModule().getVisualizer().getScenarioVisualizer().createGraphicScenario();
        
            if (getLearningModule().getMode() == LeviModule.EDITORMODE) {
               // set the module in the simulation mode
                getLearningModule().setMode(LeviModule.SIMULATIONMODE);
                getLearningModule().getFrame().changeMode();
            }
            
            getLearningModule().getSimulator().playSimulation();
	            
        }

        // TRACE OUTPUT
        if (LeviModule.isTraceActive()) System.out.println("END leviActionPlaySimulation.actionPerformed");

    }
}

