/* leviActionQuit.java
 * 
 * Created on 02.03.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;
import javax.swing.*;

import learningVisualizations.LeviModule;
import learningVisualizations.LeviResourceManager;



/**
 * @author sirocic
 *
 * Class: leviActionQuit
 * 
 * Description: The class "leviActionQuit" is the class which realizes the function of
 * 				the menu item and the button "Quit", respectively.
 * 
 * Date:	02.03.2005
 */
public class LeviActionQuit extends LeviAbstractAction
{
	static final long serialVersionUID=1;

	//	 Constructors
	public LeviActionQuit()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionQuit(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionQuit(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionQuit(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	// END	 Constructors
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Quit". 
   * 
   * Date: 		02.03.2005
   */		
	public void actionPerformed(ActionEvent event)
	{
		LeviResourceManager resourcen;
		int i;
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionQuit.actionPerformed: event="+event.toString());
	
	 	// FIND THE RESOURCES FOR THE DIALOG TITEL AND THE QUESTION ...
	  	resourcen = getLearningModule().getRessources();
	  	
	    // SHOW QUIT DIALOG
	  	getLearningModule().getQuitDialog().showDialog(true);
        
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionQuit.actionPerformed");
	
	}// END actionPerformed
	
}