/* leviActionSaveAsScenario.java
 * 
 * Created on 02.03.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;
import java.io.*;

import javax.swing.*;

import learningVisualizations.LeviModule;




/**
 * @author sirocic
 *
 * Class: leviActionSaveAsScenario
 * 
 * Description: The class "leviActionSaveAsScenario" is the class which realizes the function of
 * 				the menu item and the button "Save scenario", respectively.
 * 
 * Date:	02.03.2005
 */
public class LeviActionSaveAsScenario extends LeviAbstractAction
{
	static final long serialVersionUID=1;

	//	 Constructors
	public LeviActionSaveAsScenario()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionSaveAsScenario(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	public LeviActionSaveAsScenario(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	// END	 Constructors
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Save scenario". 
   * 
   * Date: 		02.03.2005
   */		
	public void actionPerformed(ActionEvent event)
	{

		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionSaveAsScenario.actionPerformed: event="+event.toString());
		
        // Ist die Komponente im SIMULAITONSMODUS d.h. luft gerade die Visualisierung???
        if (getLearningModule().getMode() == LeviModule.SIMULATIONMODE) {
        	// SIMULATION STOPPEN !!!
			// Wenn es einen ActionButton gibt der disabled ist, 
			// wird dieser wieder auf enable gesetzt.
			resetActiveAction();
			
			getLearningModule().getSimulator().stopSimulation();
			
			if ( getLearningModule().getView() == LeviModule.SELFSTUDYVIEW) {
				// In der Selbststudiumssicht muss die Komponente zurck in den Editormodus.
				 getLearningModule().setMode(LeviModule.EDITORMODE);
				 getLearningModule().getFrame().changeMode();
			}
        }
        
        // JETZT SPEICHERN EINLEITEN
		getLearningModule().askUserForFile();
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionSaveAsScenario.actionPerformed");

	}
}