/* leviActionSaveSleepFactor.java
 * 
 * Created on 18.05.2006
 * @author sirocic
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.*;

import learningVisualizations.LeviModule;




/**
 * @author sirocic
 *
 * Class: leviActionSaveSleepFactor
 * 
 * Description: The class "leviActionSaveSleepFactor" is the class which realizes the function of
 * 				the menu item and the button "Save Sleep Factor", respectively.
 * 
 * Date:	18.05.2006
 */
public class LeviActionSaveSleepFactor extends LeviAbstractAction
{
	static final long serialVersionUID=1;

	//	 Constructors
	public LeviActionSaveSleepFactor()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionSaveSleepFactor(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	public LeviActionSaveSleepFactor(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	// END	 Constructors
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Save as Defaul Scenario". 
   * 
   * Date: 		18.05.2006
   */			
	public void actionPerformed(ActionEvent event)
	{
		int sleepFactor;
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionSaveSleepFactor.actionPerformed: event="+event.toString());

		sleepFactor = getLearningModule().getSimulator().getSleepFactor();
		getLearningModule().getConfiguration().putSettingByKey("SleepFactor", sleepFactor);
		getLearningModule().getConfiguration().saveConfiguration();
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionSaveSleepFactor.actionPerformed");

	}
}

