/* leviActionSelectDefaultScenario.java
 * 
 * Created on 22.03.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.*;

import learningVisualizations.LeviModule;




/**
 * @author sirocic
 *
 * Class: leviActionSelectDefaultScenario
 * 
 * Description: The class "leviActionSelectDefaultScenario" is the class which realizes the function of
 * 				the menu item and the button "SaveAs Default scenario", respectively.
 * 
 * Date:	22.03.2005
 */
public class LeviActionSelectDefaultScenario extends LeviAbstractAction
{

	//	 Constructors
	public LeviActionSelectDefaultScenario()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionSelectDefaultScenario(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	public LeviActionSelectDefaultScenario(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	// END	 Constructors
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Save as Defaul scenario". 
   * 
   * Date: 		22.03.2005
   */			
	public void actionPerformed(ActionEvent event)
	{
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionSelectDefaultScenario.actionPerformed: event="+event.toString());

		getLearningModule().getDefaultScenarioConfigDialog().showDialog(true);
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionSelectDefaultScenario.actionPerformed");

	}
}
