/*
 * $Id: LeviActionSetActiveScenario.java,v 1.2 2009/04/01 13:55:00 sirocic Exp $
 *
 */
package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import learningVisualizations.LeviModule;
import learningVisualizations.LeviResourceManager;
import learningVisualizations.scenario.LeviScenario;

/**
 * An Action to set the currently displayed/edited scenario.
 *
 * @author Dirk Frsterling <r@zorbla.de>
 *
 */
public class LeviActionSetActiveScenario extends LeviAbstractAction {

    LeviScenario scenario = null;
   
    //	 Constructors
	public LeviActionSetActiveScenario()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionSetActiveScenario(LeviModule learningModule, LeviScenario scenario, String name, KeyStroke acc)
	{
		this.scenario = scenario;
        
		putValue(Action.NAME, name);
		putValue("SCENARIO", scenario);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	public LeviActionSetActiveScenario(LeviModule learningModule, LeviScenario scenario,String name, Icon icon, String tip)
	{
		this.scenario = scenario;
       
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);

	}
	// END	 Constructors


    /**
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
    	
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL LeviActionSetActiveScenario.actionPerformed: event="+e.toString());

		scenario = (LeviScenario) getValue("SCENARIO");
		
		getLearningModule().setActiveScenario(scenario);
		 
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END LeviActionSetActiveScenario.actionPerformed");

       
    }
    
	public LeviScenario getScenario() {
		return scenario;
	}

    

}
