/* leviActionStopSimulation.java
 * 
 * Created on 03.03.2005
 * Autor: Birgit Sirocic
 * 
 */
package learningVisualizations.gui.actions;

import java.awt.EventQueue;
import java.awt.event.ActionEvent;

import javax.swing.*;

import learningVisualizations.LeviModule;



/**
 * @author sirocic
 *
 * Class: leviActionStopSimulation
 * 
 * Description: The class "leviActionStopSimulation" is the class which realizes the function of
 * 				the menu item and the button "Stop", respectively.
 * 
 * Date:	03.03.2005
 */
public class LeviActionStopSimulation extends LeviAbstractAction
{
	static final long serialVersionUID=1;

	//	 Constructors
	public LeviActionStopSimulation()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionStopSimulation(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionStopSimulation(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionStopSimulation(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	// END	 Constructors
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Stop". 
   * 
   * Date: 		03.03.2005
   */		
	public void actionPerformed(ActionEvent event)
	{
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionStopSimulation.actionPerformed: event="+event.toString());

		// Wenn es einen ActionButton gibt der disabled ist, 
		// wird dieser wieder auf enable gesetzt.
		resetActiveAction();
		
        if (getLearningModule().getVisualizer().isBusy()) {
        	// Es sind noch Animationen akiv vom vorherigen Schritt.
        	// Die mssen abgebrochen werden. Der Endzustand des vorherigen Schritts muss
        	// eingestellt werden.
	        try {
			       EventQueue.invokeLater( new Runnable() {
		                  public void run() {
		                	  getLearningModule().getVisualizer().getScenarioVisualizer().cancelAnimation(true);
		                  }
		           }); 
			}
		    catch (Exception exception)
		    {
		        // Irgendwas ist mit dem Repaint wohl nicht richtig gelaufen!!!
		    	System.out.println("ERROR (leviActionStopSimulation)"+exception.getMessage());
		    }
        }
        
		getLearningModule().getSimulator().stopSimulation();
		
		// set the module back in the edit mode
		getLearningModule().setMode(LeviModule.EDITORMODE);
		getLearningModule().getFrame().changeMode();

		if ( getLearningModule().getView() == LeviModule.LECTUREVIEW)
			getLearningModule().getVisualizer().repaintMe();

		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionStopSimulation.actionPerformed");

	}
	
}

