package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.KeyStroke;

import learningVisualizations.LeviModule;


/**
 * @author sirocic
 *
 * Class: leviActionTooltipsConfig
 * 
 * Description: The class "leviActionTooltipsConfig" is the class which stores the tooltips settings
 * 				in the configuration. That means, the user can decide if the tooltips should be
 * 				active or inactive after the start of the module.
 * 
 * Date:	27.04.2006
 */
public class LeviActionTooltipsConfig extends LeviAbstractAction
{
	static final long serialVersionUID=1;
	
	//	 Constructors
	public LeviActionTooltipsConfig()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionTooltipsConfig(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionTooltipsConfig(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionTooltipsConfig(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	//	 END	 Constructors
	
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Help on/off". 
   * 
   * Date: 		29.06.2005
   */
	public void actionPerformed(ActionEvent event)
	{
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionTooltipsConfig.actionPerformed: event="+event.toString());		
		
		// update the new value in the configuration
		if (getKeyLabel().endsWith("on")) {
			// Help soll standardmig sichtbar sein !!!
			getLearningModule().getConfiguration().putSettingByKey("Tooltips",true);
			// Menu-Item fr das Anzeigen der Hilfe anpassen ...
            getLearningModule().getFrame().changeItemText(
            getLearningModule().getFrame().getMenubar().getMenuConfiguration(),"konfig.tooltipson","konfig.tooltipsoff");
			setKeyLabel("konfig.tooltipsoff");
		}
		else if (getKeyLabel().endsWith("off")) {
			getLearningModule().getConfiguration().putSettingByKey("Tooltips",false);
			// Menu-Item fr das Anzeigen der Hilfe anpassen ...
            getLearningModule().getFrame().changeItemText(
            getLearningModule().getFrame().getMenubar().getMenuConfiguration(),"konfig.tooltipsoff","konfig.tooltipson");
			setKeyLabel("konfig.tooltipson");
		}
		
		// Abspeichern der Konfiguration
		getLearningModule().getConfiguration().saveConfiguration();
	
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionTooltipsConfig.actionPerformed");

	}
}

