package learningVisualizations.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.KeyStroke;

import learningVisualizations.LeviModule;
import learningVisualizations.gui.LeviFrame;


/**
 * @author sirocic
 *
 * Class: leviActionTooltipsOnOff
 * 
 * Description: The class "leviActionTooltipsOnOff" is the class which realizes the function of
 * 				the menu item "Tooltips on/off".
 * 
 * Date:	03.03.2005
 */
public class LeviActionTooltipsOnOff extends LeviAbstractAction
{
	static final long serialVersionUID=1;
	
	//	 Constructors
	public LeviActionTooltipsOnOff()
	{
		// Is needed for the instantiation in the class leviMenu!!
	}
	public LeviActionTooltipsOnOff(LeviModule learningModule, String name)
	{
		putValue(Action.NAME, name);
		setLearningModule(learningModule);
	}
	public LeviActionTooltipsOnOff(LeviModule learningModule, String name, Icon icon, String tip)
	{
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.SHORT_DESCRIPTION, tip);
		setLearningModule(learningModule);
	}
	public LeviActionTooltipsOnOff(LeviModule learningModule, String name, KeyStroke acc)
	{
		putValue(Action.NAME, name);
		putValue(Action.ACCELERATOR_KEY, acc);
		setLearningModule(learningModule);
	}
	//	 END	 Constructors
	
	
  /*
   * @author sirocic
   *
   * Methode:		actionPerformed
   * 
   * Description:	Realizing the function of the menu item or button "Help on/off". 
   * 
   * Date: 		29.06.2005
   */
	public void actionPerformed(ActionEvent event)
	{
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("CALL leviActionTooltipsOnOff.actionPerformed: event="+event.toString());		
		
		if (getLearningModule().isTooltipsVisible()) {
			getLearningModule().setTooltipsVisible(false);
			
			// Menu-Item fr das Anzeigen der Hilfe anpassen ...
            getLearningModule().getFrame().changeItemText(
            getLearningModule().getFrame().getMenubar().getMenuView(),"viewmode.tooltips.off","viewmode.tooltips.on");
		}
		else {
			getLearningModule().setTooltipsVisible(true);
			
			// Menu-Item fr das Anzeigen der Hilfe anpassen ...
            getLearningModule().getFrame().changeItemText(
            getLearningModule().getFrame().getMenubar().getMenuView(),"viewmode.tooltips.on","viewmode.tooltips.off");
		}

		getLearningModule().updateDialogsColorLanguageFonts();
		
		// TRACE OUTPUT
		if (LeviModule.isTraceActive()) System.out.println("END leviActionTooltipsOnOff.actionPerformed");

	}
}

