/* HyperlinkListenerPN.java
 * 
 * Created on 14.10.2006
 * @author birgit
 */
package learningVisualizations.help;

import java.net.URL;

import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.HyperlinkEvent.EventType;

import learningVisualizations.LeviModule;

/**
 * @author sirocic
 *
 * Class: HelpPN
 * 
 * Description: The class "HelpPN" is the general help.
 * 
 * Date:	30.08.2005
 */
public class LeviHyperlinkListener implements HyperlinkListener {

	private LeviHelp myHelp;
	
   /*
    * Methode:   Contructors
    * 
    * Date: 		23.06.2005
    * @author    sirocic
    */
    public LeviHyperlinkListener() {
 	   	super();
    }
    public LeviHyperlinkListener(LeviHelp myHelp) {
    	this.myHelp = myHelp;
    }
	    
   
    /*
     * Methode:		hyperlinkUpdate
     * 
     * Description:	Wird aufgerufen, wenn ein Link innerhalb der Seite angeklickt wurde.
     *    
     * Parameters:   e = zugehriges Event
     * 
     * Date: 		 23.08.2006
     * @author        Frsterling
     */	
    public void hyperlinkUpdate(HyperlinkEvent e) {
 	   URL eventURL;
 	   String file;


   	  // TRACE OUTPUT
   	  if (LeviModule.isTraceActive()) System.out.println("CALL leviHyperlinkListener.hyperlinkUpdate:");
     
       if(e.getEventType().equals(EventType.ACTIVATED)) {
            eventURL = e.getURL();
            file = eventURL.getFile();
            file =  file.substring(file.lastIndexOf("/")+1);
            myHelp.setNewContent(file);
       }
        
   	  // TRACE OUTPUT
   	  if (LeviModule.isTraceActive()) System.out.println("END leviHyperlinkListener.hyperlinkUpdate:");


    } 
	    
}
