package learningVisualizations.scenario;

import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public interface LeviScenarioInterface {

	/**
     * Methode:		buildDOMElements
     *
     * Description:	Creates the DOM structure of the current scenario.
     *
     * Parameters:   return = The DOM element scenario
     *
     * Date: 		 21.04.2006
     * @param scenario
     * @param xmlDoc
     * @return The scenario as DOM Element tree.
     * @author        sirocic
     */
    public Element buildDOMElements(Element scenario, Document xmlDoc) throws ParserConfigurationException ;

    /*
     * Methode:		checkScenario
     *
     * Description:	Checks if the scenario is a correct scenario or not.
     * 				HAVE TO BE SPECIFIED IN THE SUBCLASS !!!
     *
     * Parameters:   return = true if the current scenario is a correct simulatable scenario
     *
     * Date: 		 28.09.2005
     * @author        sirocic
     */
    public boolean checkScenario() ;
    
    /*
     * Methode:		isOk
     *
     * Description:	Returns the result value of the scenario check.
     *
     * Parameters:   return = true if the current scenario is a correct simulatable scenario
     *
     * Date: 		 28.09.2005
     * @author        sirocic
     */
    public boolean isOk();
    
    public String getName();
    public boolean isOpen();
    public boolean hasChanged();
    
    public void setName(String name);
    public void setChanged();
    public void setUnchanged();
	public void setOpen(boolean value);
	
}
