package learningVisualizations.simulator;

public interface LeviSimulatorInterface {

	/*
    * Methode:		playSimulation
    *
    * Description:	Starten den Endlosablauf der Simulation. Der Simulator-Thread luft
    *               bis stopsimulation oder pausSimulation aufgerufen wird.
    *
    * Parameters:
    *
    * Date: 		 20.01.2006
    * @author        sirocic
    */
   public void playSimulation();
   
   /*
    * Methode:		stepForwardSimulation
    *
    * Description:	Veranlat den Simulator einen Schritt weiter zu simulieren und dann wieder
    *               anzuhalten.
    *
    * Parameters:
    *
    * Date: 		 20.01.2006
    * @author        sirocic
    */
   public void stepForwardSimulation();
	   
   /*
    * Methode:		stepBackwardSimulation
    *
    * Description:	Veranlat den Simulator einen Schritt zurck zu simulieren und dann wieder
    *               anzuhalten.
    *
    * Parameters:
    *
    * Date: 		 20.01.2006
    * @author        sirocic
    */
   public void stepBackwardSimulation();
   
	/*
    * Methode:		pauseSimulation
    *
    * Description:	Hlt die Simulation an.
    *
    * Parameters:
    *
    * Date: 		 20.01.2006
    * @author        sirocic
    */
   public void pauseSimulation();
	   
   /*
    * Methode:		speedupSimulation
    *
    * Description:	Beschleunigt die Simulation. Inkrementieren eines Factors fr die Lnge
    *               des Waits im Simulationszyklus.
    *
    * Parameters:
    *
    * Date: 		 16.05.2006
    * @author        sirocic
    */
   public void speedupSimulation();
   
   /*
    * Methode:		slowdownSimulation
    *
    * Description:	Verlangsamt die Simulation. Dekrementieren eines Factors fr die Lnge
    *               des Waits im Simulationszyklus.
    *
    * Parameters:
    *
    * Date: 		 16.05.2006
    * @author        sirocic
    */
   public void slowdownSimulation();
   
	/*
    * Methode:		stopSimulation
    *
    * Description:	Hlt die Simulation an und setzt den Simulator zurck auf den
    *               Simulationsstartpunkt.
    *
    * Parameters:
    *
    * Date: 		 20.01.2006
    * @author        sirocic
    */
   public void stopSimulation();
   public void requestStop();
   public void startSimulatorThread();
	   
	public  boolean executeStep() ;
	public  void executeStepBack();
	public boolean isStop();
	public boolean isPause();
	public boolean isPlay();
	
	public int getSleepUnit();
	public int getSleepFactor();
	public LeviSuspendRequestor getSuspender();
	public LeviTimer getTimer();
	   
}
