/* leviSuspendRequestor.java
 * 
 * Created on 29.09.2005
 * @author sirocic
 */
package learningVisualizations.simulator;

/**
 * @author sirocic
 *
 * Class:       leviSuspendRequestor
 * 
 * Description: The class "leviSuspendRequestor" is the general suspend requester for the levi simulator thread.
 * 
 * Date:	    29.09.2005
 */
public class LeviSuspendRequestor {

	private boolean suspendRequested;
	
	public synchronized void set(boolean b)
	{
		suspendRequested = b;
		notifyAll();
	}
	
	public synchronized void waitForResume()
	   throws InterruptedException
    {
		while (suspendRequested)
			wait();
    }
	
	public boolean isSuspendRequested()
	{
		return suspendRequested;
	}

}
