/* leviTimer.java
 *
 * $Id: LeviTimer.java,v 1.1 2009/04/01 09:57:09 sirocic Exp $
 *
 * Created on 28.09.2005
 * @author sirocic
 */
package learningVisualizations.simulator;

/**
 * @author sirocic
 *
 * Class: leviTimer
 *
 * Description: The class "leviTimer" is the general timer.
 *
 * Date:	28.09.2005
 */
public class LeviTimer {

    private int time;
    private int step;

  /*
   * Methode:		Contructors
   * Description:
   * Date: 		28.09.2005
   * @author sirocic
   */
   public LeviTimer() {

      time = 0;
      step = 1;

   }

   /*
    * Methode:		reset
    *
    * Description:	Resets the timer to 0.
    *
    * Parameters:
    *
    * Date: 		 28.09.2005
    * @author        sirocic
    */
   public void reset() {
       time=0;
   }

   /*
    * Methode:		nextTime
    *
    * Description:	Increments the timer by 1 and returns the new time value.
    *
    * Parameters:
    *
    * Date: 		 28.09.2005
    * @author        sirocic
    */
   public int nextTime() {
       time = time + step;
       return time;
   }

   /*
    * Methode:		previousTime
    *
    * Description:	Decrements the timer by 1 and returns the new time value.
    *
    * Parameters:
    *
    * Date: 		 01.12.2005
    * @author        sirocic
    */
   public int previousTime() {
       if (time>0) time = time - step;
       return time;
   }

   /*
    * Methode:		setTime
    *
    * Description:	Sets the timer to the given time value.
    *
    * Parameters:
    *
    * Date: 		 28.09.2005
    * @author        sirocic
    */
   public void setTime(int newtime) {
       time = newtime;
   }

   /*
    * Methode:		setStep
    *
    * Description:	Sets the step width to the timer.
    *
    * Parameters:
    *
    * Date: 		 11.11.2006
    * @author        sirocic
    */
   public void setStep(int step) {
       this.step = step;
   }
   
   /*
    * Methode:		getTime
    *
    * Description:	Returns the current time value.
    *
    * Parameters:
    *
    * Date: 		 28.09.2005
    * @author        sirocic
    */
   public int getTime() {
       return time;
   }

   /*
    * Methode:		getStep
    *
    * Description:	Returns the current step width.
    *
    * Parameters:
    *
    * Date: 		 11.11.2006
    * @author        sirocic
    */
   public int getStep() {
       return step;
   }
   
   /**
    * Methode:		getTimeDigital
    *
    * Description:	Returns the current time as string in a digital format.
    *
    * Parameters:
    *
    * Date: 		 29.09.2005
    * @author        sirocic
    * @return   string representation of this leviTimer's time.
    */
   public String getTimeDigital() {
       int h = 0;
       int m = 0;
       int s = 0;
       StringBuffer b = new StringBuffer(8);

       h = time / (3600);
       if( h < 10) b.append("0");
       b.append( h ).append(":");

       m = ( time - h * 3600 ) / 60;
       if( m < 10) b.append("0");
       b.append( m ).append(":");

       s = ( time - (h * 3600) - (m * 60) );
       if( s < 10) b.append("0");
       b.append( s );

       return b.toString();
   }
}
