package learningVisualizations.visualizer;

import java.awt.event.MouseListener;

public interface LeviScenarioVisualizerInterface {

	   /*
	    * Methode:		createGraphicScenario
	    *
	    * Description:	Creates the graphic elements for the current scenario and repaints the panel.
	    * 				This have to be done in the component subclass.
	    *
	    * Parameters:
	    *
	    * Date: 		 18.10.2006
	    * @author        sirocic
	    */
	   public abstract void createGraphicScenario();
	   
	   /*
	    * Methode:		cleanMe
	    *
	    * Description:	Deletes all graphical element from the scenarioPanel.
	    *
	    * Parameters:
	    *
	    * Date: 		 05.05.2006
	    * @author        sirocic
	    */
	   public void cleanMe() ;
	   
	   /*
	    * Methode:		cancelAnimation
	    *
	    * Description:	Abrechen der aktuellen Animationen. Springen in den nchsten Zustand ohne 
	    *               das die Animation vollstndig durchgelaufen ist.
	    *
	    * Date: 		 12.10.2006
	    * @author        sirocic
	    */
	   public void cancelAnimation(boolean cancelByBackOrStop);
	   
	   public void removePopupListener() ;
	   public MouseListener getPopupListener();
	   public void setPopupListener(MouseListener listener);
	   

		/*
	    * Methode:		updateLanguageColorFonts
	    *
	    * Description:	Ldt sprachabhngige Teile neu. In der Toolbar knnen z.B. sprachabhngige
	    * 				Buttons sein 
	    *
	    * Date: 		12.03.2007
	    * 
	    * @author sirocic
	    */
	   public abstract void updateLanguageColorFonts() ;
	   
	   public int getWidth();
	   public int getHeight();
	
	   
}
